/* filehelper.c generated by valac 0.26.1, the Vala compiler
 * generated from filehelper.vala, do not modify */

/* filehelper.vala
 *
 * Copyright (C) 2008-2009 Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Brosch Florian <flo.brosch@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>

#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_dir_close0(var) ((var == NULL) ? NULL : (var = (g_dir_close (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gboolean valadoc_copy_file (const gchar* src, const gchar* dest);
gboolean valadoc_copy_directory (const gchar* src, const gchar* dest);
gboolean valadoc_remove_directory (const gchar* rpath);
gboolean valadoc_ends_with_dir_separator (const gchar* s);
gchar* valadoc_realpath (const gchar* name);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Makes a copy of the file src to dest. 
 *
 * @param src the file to copy
 * @param dest the destination path
 */
gboolean valadoc_copy_file (const gchar* src, const gchar* dest) {
	gboolean result = FALSE;
	FILE* fsrc = NULL;
	const gchar* _tmp0_ = NULL;
	FILE* _tmp1_ = NULL;
	FILE* _tmp2_ = NULL;
	FILE* fdest = NULL;
	const gchar* _tmp3_ = NULL;
	FILE* _tmp4_ = NULL;
	FILE* _tmp5_ = NULL;
#line 35 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (src != NULL, FALSE);
#line 35 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 36 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp0_ = src;
#line 36 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp1_ = g_fopen (_tmp0_, "rb");
#line 36 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	fsrc = _tmp1_;
#line 37 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp2_ = fsrc;
#line 37 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	if (_tmp2_ == NULL) {
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		result = FALSE;
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_fclose0 (fsrc);
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		return result;
#line 87 "filehelper.c"
	}
#line 41 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp3_ = dest;
#line 41 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp4_ = g_fopen (_tmp3_, "wb");
#line 41 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	fdest = _tmp4_;
#line 42 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp5_ = fdest;
#line 42 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	if (_tmp5_ == NULL) {
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		result = FALSE;
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_fclose0 (fdest);
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_fclose0 (fsrc);
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		return result;
#line 107 "filehelper.c"
	}
	{
		gint c = 0;
		FILE* _tmp6_ = NULL;
		gint _tmp7_ = 0;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp6_ = fsrc;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp7_ = fgetc (_tmp6_);
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		c = _tmp7_;
#line 119 "filehelper.c"
		{
			gboolean _tmp8_ = FALSE;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp8_ = TRUE;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			while (TRUE) {
#line 126 "filehelper.c"
				FILE* _tmp11_ = NULL;
				gboolean _tmp12_ = FALSE;
				FILE* _tmp13_ = NULL;
				gint _tmp14_ = 0;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				if (!_tmp8_) {
#line 133 "filehelper.c"
					FILE* _tmp9_ = NULL;
					gint _tmp10_ = 0;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp9_ = fsrc;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp10_ = fgetc (_tmp9_);
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					c = _tmp10_;
#line 142 "filehelper.c"
				}
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp8_ = FALSE;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp11_ = fsrc;
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp12_ = feof (_tmp11_);
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				if (!(!_tmp12_)) {
#line 46 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					break;
#line 154 "filehelper.c"
				}
#line 47 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp13_ = fdest;
#line 47 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp14_ = c;
#line 47 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				fputc ((gchar) _tmp14_, _tmp13_);
#line 162 "filehelper.c"
			}
		}
	}
#line 50 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	result = TRUE;
#line 50 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_fclose0 (fdest);
#line 50 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_fclose0 (fsrc);
#line 50 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	return result;
#line 174 "filehelper.c"
}


/**
 * Makes a copy of the directory src to dest. 
 *
 * @param src the directory to copy
 * @param dest the destination path
 */
gboolean valadoc_copy_directory (const gchar* src, const gchar* dest) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 59 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (src != NULL, FALSE);
#line 59 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (dest != NULL, FALSE);
#line 191 "filehelper.c"
	{
		GDir* dir = NULL;
		const gchar* _tmp0_ = NULL;
		GDir* _tmp1_ = NULL;
#line 61 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp0_ = src;
#line 61 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp1_ = g_dir_open (_tmp0_, (guint) 0, &_inner_error_);
#line 61 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		dir = _tmp1_;
#line 61 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 61 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 206 "filehelper.c"
				goto __catch1_g_file_error;
			}
#line 61 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 61 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			g_clear_error (&_inner_error_);
#line 61 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			return FALSE;
#line 215 "filehelper.c"
		}
		{
			gchar* file = NULL;
			const gchar* _tmp2_ = NULL;
			gchar* _tmp3_ = NULL;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp2_ = g_dir_read_name (dir);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp3_ = g_strdup (_tmp2_);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			file = _tmp3_;
#line 227 "filehelper.c"
			{
				gboolean _tmp4_ = FALSE;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp4_ = TRUE;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				while (TRUE) {
#line 234 "filehelper.c"
					const gchar* _tmp7_ = NULL;
					gchar* src_file_path = NULL;
					const gchar* _tmp8_ = NULL;
					const gchar* _tmp9_ = NULL;
					gchar* _tmp10_ = NULL;
					gchar* dest_file_path = NULL;
					const gchar* _tmp11_ = NULL;
					const gchar* _tmp12_ = NULL;
					gchar* _tmp13_ = NULL;
					const gchar* _tmp14_ = NULL;
					gboolean _tmp15_ = FALSE;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (!_tmp4_) {
#line 248 "filehelper.c"
						const gchar* _tmp5_ = NULL;
						gchar* _tmp6_ = NULL;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp5_ = g_dir_read_name (dir);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp6_ = g_strdup (_tmp5_);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_g_free0 (file);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						file = _tmp6_;
#line 259 "filehelper.c"
					}
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp4_ = FALSE;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp7_ = file;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (!(_tmp7_ != NULL)) {
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						break;
#line 269 "filehelper.c"
					}
#line 63 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp8_ = src;
#line 63 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp9_ = file;
#line 63 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp10_ = g_build_filename (_tmp8_, _tmp9_, NULL);
#line 63 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					src_file_path = _tmp10_;
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp11_ = dest;
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp12_ = file;
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp13_ = g_build_filename (_tmp11_, _tmp12_, NULL);
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					dest_file_path = _tmp13_;
#line 65 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp14_ = src_file_path;
#line 65 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp15_ = g_file_test (_tmp14_, G_FILE_TEST_IS_DIR);
#line 65 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (_tmp15_) {
#line 293 "filehelper.c"
						const gchar* _tmp16_ = NULL;
						const gchar* _tmp17_ = NULL;
						const gchar* _tmp18_ = NULL;
						gboolean _tmp19_ = FALSE;
#line 66 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp16_ = dest_file_path;
#line 66 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						g_mkdir (_tmp16_, 0755);
#line 67 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp17_ = src_file_path;
#line 67 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp18_ = dest_file_path;
#line 67 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp19_ = valadoc_copy_directory (_tmp17_, _tmp18_);
#line 67 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						if (!_tmp19_) {
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							result = FALSE;
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (dest_file_path);
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (src_file_path);
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (file);
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_dir_close0 (dir);
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							return result;
#line 322 "filehelper.c"
						}
					} else {
						const gchar* _tmp20_ = NULL;
						const gchar* _tmp21_ = NULL;
						gboolean _tmp22_ = FALSE;
#line 71 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp20_ = src_file_path;
#line 71 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp21_ = dest_file_path;
#line 71 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp22_ = valadoc_copy_file (_tmp20_, _tmp21_);
#line 71 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						if (!_tmp22_) {
#line 72 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							result = FALSE;
#line 72 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (dest_file_path);
#line 72 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (src_file_path);
#line 72 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (file);
#line 72 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_dir_close0 (dir);
#line 72 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							return result;
#line 348 "filehelper.c"
						}
					}
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_g_free0 (dest_file_path);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_g_free0 (src_file_path);
#line 355 "filehelper.c"
				}
			}
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_g_free0 (file);
#line 360 "filehelper.c"
		}
#line 60 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_g_dir_close0 (dir);
#line 364 "filehelper.c"
	}
	goto __finally1;
	__catch1_g_file_error:
	{
		GError* err = NULL;
#line 60 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		err = _inner_error_;
#line 60 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_inner_error_ = NULL;
#line 78 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		result = FALSE;
#line 78 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_g_error_free0 (err);
#line 78 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		return result;
#line 380 "filehelper.c"
	}
	__finally1:
#line 60 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 60 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 60 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		g_clear_error (&_inner_error_);
#line 60 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		return FALSE;
#line 391 "filehelper.c"
	}
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	result = TRUE;
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	return result;
#line 397 "filehelper.c"
}


/**
 * A recursive directory delete function
 *
 * @param rpath the directory to remove
 */
gboolean valadoc_remove_directory (const gchar* rpath) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 88 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (rpath != NULL, FALSE);
#line 411 "filehelper.c"
	{
		GDir* dir = NULL;
		const gchar* _tmp0_ = NULL;
		GDir* _tmp1_ = NULL;
		GDir* _tmp2_ = NULL;
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp0_ = rpath;
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp1_ = g_dir_open (_tmp0_, (guint) 0, &_inner_error_);
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		dir = _tmp1_;
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 427 "filehelper.c"
				goto __catch2_g_file_error;
			}
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			g_clear_error (&_inner_error_);
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			return FALSE;
#line 436 "filehelper.c"
		}
#line 91 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp2_ = dir;
#line 91 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		if (_tmp2_ == NULL) {
#line 92 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			result = FALSE;
#line 92 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_g_dir_close0 (dir);
#line 92 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			return result;
#line 448 "filehelper.c"
		}
		{
			const gchar* entry = NULL;
			GDir* _tmp3_ = NULL;
			const gchar* _tmp4_ = NULL;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp3_ = dir;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp4_ = g_dir_read_name (_tmp3_);
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			entry = _tmp4_;
#line 460 "filehelper.c"
			{
				gboolean _tmp5_ = FALSE;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp5_ = TRUE;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				while (TRUE) {
#line 467 "filehelper.c"
					const gchar* _tmp8_ = NULL;
					gchar* path = NULL;
					const gchar* _tmp9_ = NULL;
					const gchar* _tmp10_ = NULL;
					gchar* _tmp11_ = NULL;
					gboolean is_dir = FALSE;
					const gchar* _tmp12_ = NULL;
					gboolean _tmp13_ = FALSE;
					gboolean _tmp14_ = FALSE;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (!_tmp5_) {
#line 479 "filehelper.c"
						GDir* _tmp6_ = NULL;
						const gchar* _tmp7_ = NULL;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp6_ = dir;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp7_ = g_dir_read_name (_tmp6_);
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						entry = _tmp7_;
#line 488 "filehelper.c"
					}
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp5_ = FALSE;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp8_ = entry;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (!(_tmp8_ != NULL)) {
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						break;
#line 498 "filehelper.c"
					}
#line 95 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp9_ = rpath;
#line 95 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp10_ = entry;
#line 95 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp11_ = g_strconcat (_tmp9_, _tmp10_, NULL);
#line 95 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					path = _tmp11_;
#line 97 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp12_ = path;
#line 97 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp13_ = g_file_test (_tmp12_, G_FILE_TEST_IS_DIR);
#line 97 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					is_dir = _tmp13_;
#line 98 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp14_ = is_dir;
#line 98 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (_tmp14_ == TRUE) {
#line 518 "filehelper.c"
						gboolean tmp = FALSE;
						const gchar* _tmp15_ = NULL;
						gboolean _tmp16_ = FALSE;
						gboolean _tmp17_ = FALSE;
#line 99 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp15_ = path;
#line 99 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp16_ = valadoc_remove_directory (_tmp15_);
#line 99 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						tmp = _tmp16_;
#line 100 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp17_ = tmp;
#line 100 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						if (_tmp17_ == FALSE) {
#line 101 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							result = FALSE;
#line 101 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (path);
#line 101 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_dir_close0 (dir);
#line 101 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							return result;
#line 541 "filehelper.c"
						}
					} else {
						gint tmp = 0;
						const gchar* _tmp18_ = NULL;
						gint _tmp19_ = 0;
						gint _tmp20_ = 0;
#line 104 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp18_ = path;
#line 104 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp19_ = g_unlink (_tmp18_);
#line 104 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						tmp = _tmp19_;
#line 105 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp20_ = tmp;
#line 105 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						if (_tmp20_ > 0) {
#line 106 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							result = FALSE;
#line 106 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (path);
#line 106 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_dir_close0 (dir);
#line 106 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							return result;
#line 566 "filehelper.c"
						}
					}
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_g_free0 (path);
#line 571 "filehelper.c"
				}
			}
		}
#line 89 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_g_dir_close0 (dir);
#line 577 "filehelper.c"
	}
	goto __finally2;
	__catch2_g_file_error:
	{
		GError* err = NULL;
#line 89 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		err = _inner_error_;
#line 89 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_inner_error_ = NULL;
#line 111 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		result = FALSE;
#line 111 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_g_error_free0 (err);
#line 111 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		return result;
#line 593 "filehelper.c"
	}
	__finally2:
#line 89 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 89 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 89 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		g_clear_error (&_inner_error_);
#line 89 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		return FALSE;
#line 604 "filehelper.c"
	}
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	result = TRUE;
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	return result;
#line 610 "filehelper.c"
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_ = 0L;
	gunichar _tmp1_ = 0U;
#line 1026 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1027 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1027 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
#line 1027 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1027 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 628 "filehelper.c"
}


inline gboolean valadoc_ends_with_dir_separator (const gchar* s) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gunichar _tmp4_ = 0U;
	gboolean _tmp5_ = FALSE;
#line 118 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp0_ = s;
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp1_ = s;
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp2_ = strlen (_tmp1_);
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp3_ = _tmp2_;
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp4_ = string_get_char (_tmp0_, (glong) (_tmp3_ - 1));
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp5_ = G_IS_DIR_SEPARATOR (_tmp4_);
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	result = _tmp5_;
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	return result;
#line 658 "filehelper.c"
}


/**
 * Returns canonicalized absolute pathname
 *
 * @param name the path being checked
 * @return a canonicalized absolute pathname
 */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1197 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1197 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1197 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1197 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1198 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1198 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 687 "filehelper.c"
		glong _tmp4_ = 0L;
#line 1199 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1199 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1199 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 695 "filehelper.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1201 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1201 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1201 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1201 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 707 "filehelper.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1208 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 731 "filehelper.c"
		glong _tmp2_ = 0L;
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 737 "filehelper.c"
	} else {
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 741 "filehelper.c"
	}
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 745 "filehelper.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1212 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1212 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1212 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1212 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 757 "filehelper.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1214 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1214 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1214 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 767 "filehelper.c"
	}
#line 1217 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1217 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 773 "filehelper.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1218 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1218 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1218 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1219 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1219 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 787 "filehelper.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1221 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1221 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1221 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 797 "filehelper.c"
	}
#line 1223 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1223 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 803 "filehelper.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1224 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1224 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1224 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 812 "filehelper.c"
	}
#line 1226 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1226 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1226 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1226 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 832 "filehelper.c"
}


static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
#line 964 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = separator;
#line 964 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp0_ == NULL) {
#line 965 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		separator = "";
#line 849 "filehelper.c"
	}
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp3_ = str_array;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp3__length1 = str_array_length1;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp2_ = TRUE;
#line 859 "filehelper.c"
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = str_array;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4__length1 = str_array_length1;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp4__length1 > 0;
#line 869 "filehelper.c"
	}
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp2_) {
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 875 "filehelper.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp6_ = str_array;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp6__length1 = str_array_length1;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		if (_tmp6__length1 == (-1)) {
#line 886 "filehelper.c"
			gchar** _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
			const gchar* _tmp8_ = NULL;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_tmp7_ = str_array;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_tmp7__length1 = str_array_length1;
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_tmp8_ = _tmp7_[0];
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_tmp5_ = _tmp8_ != NULL;
#line 898 "filehelper.c"
		} else {
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 902 "filehelper.c"
		}
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp1_ = _tmp5_;
#line 906 "filehelper.c"
	}
#line 967 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 910 "filehelper.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp31_ = 0;
		gint _tmp33_ = 0;
		gint _tmp34_ = 0;
		gsize _tmp35_ = 0UL;
		const gchar* _tmp36_ = NULL;
		gint _tmp37_ = 0;
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		const gchar* res = NULL;
		gsize _tmp40_ = 0UL;
		void* _tmp41_ = NULL;
		void* ptr = NULL;
		const gchar* _tmp42_ = NULL;
		gchar** _tmp43_ = NULL;
		gint _tmp43__length1 = 0;
		const gchar* _tmp44_ = NULL;
		void* _tmp45_ = NULL;
		const gchar* _tmp62_ = NULL;
#line 969 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		len = (gsize) 1;
#line 933 "filehelper.c"
		{
			gboolean _tmp9_ = FALSE;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			i = 0;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_tmp9_ = TRUE;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 942 "filehelper.c"
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp21_ = 0;
				gchar** _tmp22_ = NULL;
				gint _tmp22__length1 = 0;
				gint _tmp23_ = 0;
				const gchar* _tmp24_ = NULL;
				gsize _tmp30_ = 0UL;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				if (!_tmp9_) {
#line 955 "filehelper.c"
					gint _tmp10_ = 0;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp10_ = i;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					i = _tmp10_ + 1;
#line 961 "filehelper.c"
				}
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp9_ = FALSE;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp13_ = str_array;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp13__length1 = str_array_length1;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				if (_tmp13__length1 != (-1)) {
#line 971 "filehelper.c"
					gint _tmp14_ = 0;
					gchar** _tmp15_ = NULL;
					gint _tmp15__length1 = 0;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp14_ = i;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp15_ = str_array;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp15__length1 = str_array_length1;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp12_ = _tmp14_ < _tmp15__length1;
#line 983 "filehelper.c"
				} else {
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp12_ = FALSE;
#line 987 "filehelper.c"
				}
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				if (_tmp12_) {
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp11_ = TRUE;
#line 993 "filehelper.c"
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_ = NULL;
					gint _tmp17__length1 = 0;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp17_ = str_array;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp17__length1 = str_array_length1;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					if (_tmp17__length1 == (-1)) {
#line 1004 "filehelper.c"
						gchar** _tmp18_ = NULL;
						gint _tmp18__length1 = 0;
						gint _tmp19_ = 0;
						const gchar* _tmp20_ = NULL;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
						_tmp18_ = str_array;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
						_tmp18__length1 = str_array_length1;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
						_tmp19_ = i;
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
						_tmp20_ = _tmp18_[_tmp19_];
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
						_tmp16_ = _tmp20_ != NULL;
#line 1019 "filehelper.c"
					} else {
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
						_tmp16_ = FALSE;
#line 1023 "filehelper.c"
					}
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp11_ = _tmp16_;
#line 1027 "filehelper.c"
				}
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				if (!_tmp11_) {
#line 970 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					break;
#line 1033 "filehelper.c"
				}
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp22_ = str_array;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp22__length1 = str_array_length1;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp23_ = i;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp24_ = _tmp22_[_tmp23_];
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				if (_tmp24_ != NULL) {
#line 1045 "filehelper.c"
					gchar** _tmp25_ = NULL;
					gint _tmp25__length1 = 0;
					gint _tmp26_ = 0;
					const gchar* _tmp27_ = NULL;
					gint _tmp28_ = 0;
					gint _tmp29_ = 0;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp25_ = str_array;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp25__length1 = str_array_length1;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp26_ = i;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp27_ = _tmp25_[_tmp26_];
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp28_ = strlen ((const gchar*) _tmp27_);
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp29_ = _tmp28_;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp21_ = _tmp29_;
#line 1066 "filehelper.c"
				} else {
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp21_ = 0;
#line 1070 "filehelper.c"
				}
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp30_ = len;
#line 971 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				len = _tmp30_ + _tmp21_;
#line 1076 "filehelper.c"
			}
		}
#line 973 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp31_ = i;
#line 973 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		if (_tmp31_ == 0) {
#line 1083 "filehelper.c"
			gchar* _tmp32_ = NULL;
#line 974 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_tmp32_ = g_strdup ("");
#line 974 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			result = _tmp32_;
#line 974 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			return result;
#line 1091 "filehelper.c"
		}
#line 976 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp33_ = i;
#line 976 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		str_array_length1 = _tmp33_;
#line 976 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp34_ = str_array_length1;
#line 977 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp35_ = len;
#line 977 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp36_ = separator;
#line 977 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp37_ = strlen ((const gchar*) _tmp36_);
#line 977 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp38_ = _tmp37_;
#line 977 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp39_ = i;
#line 977 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
#line 979 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp40_ = len;
#line 979 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp41_ = g_malloc (_tmp40_);
#line 979 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		res = _tmp41_;
#line 980 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp42_ = res;
#line 980 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp43_ = str_array;
#line 980 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp43__length1 = str_array_length1;
#line 980 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp44_ = _tmp43_[0];
#line 980 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
#line 980 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		ptr = _tmp45_;
#line 1129 "filehelper.c"
		{
			gboolean _tmp46_ = FALSE;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			i = 1;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			_tmp46_ = TRUE;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 1138 "filehelper.c"
				gint _tmp48_ = 0;
				gchar** _tmp49_ = NULL;
				gint _tmp49__length1 = 0;
				void* _tmp50_ = NULL;
				const gchar* _tmp51_ = NULL;
				void* _tmp52_ = NULL;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_ = NULL;
				gint _tmp54__length1 = 0;
				gint _tmp55_ = 0;
				const gchar* _tmp56_ = NULL;
				void* _tmp60_ = NULL;
				void* _tmp61_ = NULL;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				if (!_tmp46_) {
#line 1154 "filehelper.c"
					gint _tmp47_ = 0;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp47_ = i;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					i = _tmp47_ + 1;
#line 1160 "filehelper.c"
				}
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp46_ = FALSE;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp48_ = i;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp49_ = str_array;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp49__length1 = str_array_length1;
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				if (!(_tmp48_ < _tmp49__length1)) {
#line 981 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					break;
#line 1174 "filehelper.c"
				}
#line 982 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp50_ = ptr;
#line 982 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp51_ = separator;
#line 982 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
#line 982 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				ptr = _tmp52_;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp54_ = str_array;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp54__length1 = str_array_length1;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp55_ = i;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp56_ = _tmp54_[_tmp55_];
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				if (_tmp56_ != NULL) {
#line 1194 "filehelper.c"
					gchar** _tmp57_ = NULL;
					gint _tmp57__length1 = 0;
					gint _tmp58_ = 0;
					const gchar* _tmp59_ = NULL;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp57_ = str_array;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp57__length1 = str_array_length1;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp58_ = i;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp59_ = _tmp57_[_tmp58_];
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp53_ = (const gchar*) _tmp59_;
#line 1209 "filehelper.c"
				} else {
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
					_tmp53_ = "";
#line 1213 "filehelper.c"
				}
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp60_ = ptr;
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
#line 983 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
				ptr = _tmp61_;
#line 1221 "filehelper.c"
			}
		}
#line 986 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp62_ = res;
#line 986 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		res = NULL;
#line 986 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = (gchar*) _tmp62_;
#line 986 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 1232 "filehelper.c"
	} else {
		gchar* _tmp63_ = NULL;
#line 988 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp63_ = g_strdup ("");
#line 988 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = _tmp63_;
#line 988 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 1241 "filehelper.c"
	}
}


gchar* valadoc_realpath (const gchar* name) {
	gchar* result = NULL;
	gchar* rpath = NULL;
	const gchar* start = NULL;
	const gchar* end = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	glong root_len = 0L;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gboolean _tmp66_ = FALSE;
	const gchar* _tmp67_ = NULL;
	gint _tmp68_ = 0;
	gint _tmp69_ = 0;
	glong _tmp70_ = 0L;
#line 129 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 139 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp0_ = name;
#line 139 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp1_ = g_path_is_absolute (_tmp0_);
#line 139 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	if (!_tmp1_) {
#line 1270 "filehelper.c"
		gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
#line 141 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp2_ = g_get_current_dir ();
#line 141 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_g_free0 (rpath);
#line 141 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		rpath = _tmp2_;
#line 143 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp3_ = name;
#line 143 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		end = _tmp3_;
#line 143 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp4_ = end;
#line 143 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		start = _tmp4_;
#line 1288 "filehelper.c"
	} else {
		const gchar* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp5_ = name;
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp6_ = g_path_skip_root (_tmp5_);
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		end = _tmp6_;
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp7_ = end;
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		start = _tmp7_;
#line 149 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp8_ = name;
#line 149 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp9_ = start;
#line 149 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp10_ = name;
#line 149 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp11_ = string_substring (_tmp8_, (glong) 0, (glong) ((gint) (((gchar*) _tmp9_) - ((gchar*) _tmp10_))));
#line 149 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_g_free0 (rpath);
#line 149 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		rpath = _tmp11_;
#line 1319 "filehelper.c"
	}
#line 152 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp12_ = rpath;
#line 152 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp13_ = g_path_skip_root (_tmp12_);
#line 152 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp14_ = rpath;
#line 152 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	root_len = (glong) (((gchar*) _tmp13_) - ((gchar*) _tmp14_));
#line 1329 "filehelper.c"
	{
		gboolean _tmp15_ = FALSE;
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp15_ = TRUE;
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		while (TRUE) {
#line 1336 "filehelper.c"
			const gchar* _tmp17_ = NULL;
			gunichar _tmp18_ = 0U;
			glong len = 0L;
			glong _tmp35_ = 0L;
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			if (!_tmp15_) {
#line 1343 "filehelper.c"
				const gchar* _tmp16_ = NULL;
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp16_ = end;
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				start = _tmp16_;
#line 1349 "filehelper.c"
			}
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp15_ = FALSE;
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp17_ = start;
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp18_ = string_get_char (_tmp17_, (glong) 0);
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			if (!(_tmp18_ != ((gunichar) 0))) {
#line 154 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				break;
#line 1361 "filehelper.c"
			}
#line 156 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			while (TRUE) {
#line 1365 "filehelper.c"
				const gchar* _tmp19_ = NULL;
				gunichar _tmp20_ = 0U;
				gboolean _tmp21_ = FALSE;
				const gchar* _tmp22_ = NULL;
				const gchar* _tmp23_ = NULL;
#line 156 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp19_ = start;
#line 156 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp20_ = string_get_char (_tmp19_, (glong) 0);
#line 156 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp21_ = G_IS_DIR_SEPARATOR (_tmp20_);
#line 156 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				if (!_tmp21_) {
#line 156 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					break;
#line 1381 "filehelper.c"
				}
#line 157 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp22_ = start;
#line 157 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp23_ = g_utf8_next_char (_tmp22_);
#line 157 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				start = _tmp23_;
#line 1389 "filehelper.c"
			}
#line 161 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			len = (glong) 0;
#line 1393 "filehelper.c"
			{
				const gchar* _tmp24_ = NULL;
				gboolean _tmp25_ = FALSE;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp24_ = start;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				end = _tmp24_;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp25_ = TRUE;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				while (TRUE) {
#line 1405 "filehelper.c"
					gboolean _tmp28_ = FALSE;
					const gchar* _tmp29_ = NULL;
					gunichar _tmp30_ = 0U;
					glong _tmp34_ = 0L;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (!_tmp25_) {
#line 1412 "filehelper.c"
						const gchar* _tmp26_ = NULL;
						const gchar* _tmp27_ = NULL;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp26_ = end;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp27_ = g_utf8_next_char (_tmp26_);
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						end = _tmp27_;
#line 1421 "filehelper.c"
					}
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp25_ = FALSE;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp29_ = end;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp30_ = string_get_char (_tmp29_, (glong) 0);
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (_tmp30_ != ((gunichar) 0)) {
#line 1431 "filehelper.c"
						const gchar* _tmp31_ = NULL;
						gunichar _tmp32_ = 0U;
						gboolean _tmp33_ = FALSE;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp31_ = end;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp32_ = string_get_char (_tmp31_, (glong) 0);
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp33_ = G_IS_DIR_SEPARATOR (_tmp32_);
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp28_ = !_tmp33_;
#line 1443 "filehelper.c"
					} else {
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp28_ = FALSE;
#line 1447 "filehelper.c"
					}
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (!_tmp28_) {
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						break;
#line 1453 "filehelper.c"
					}
#line 163 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp34_ = len;
#line 163 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					len = _tmp34_ + 1;
#line 1459 "filehelper.c"
				}
			}
#line 166 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			_tmp35_ = len;
#line 166 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
			if (_tmp35_ == ((glong) 0)) {
#line 167 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				break;
#line 1468 "filehelper.c"
			} else {
				gboolean _tmp36_ = FALSE;
				glong _tmp37_ = 0L;
#line 168 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				_tmp37_ = len;
#line 168 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				if (_tmp37_ == ((glong) 1)) {
#line 1476 "filehelper.c"
					const gchar* _tmp38_ = NULL;
					gunichar _tmp39_ = 0U;
#line 168 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp38_ = start;
#line 168 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp39_ = string_get_char (_tmp38_, (glong) 0);
#line 168 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp36_ = _tmp39_ == ((gunichar) '.');
#line 1485 "filehelper.c"
				} else {
#line 168 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp36_ = FALSE;
#line 1489 "filehelper.c"
				}
#line 168 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
				if (_tmp36_) {
#line 1493 "filehelper.c"
				} else {
					gboolean _tmp40_ = FALSE;
					glong _tmp41_ = 0L;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					_tmp41_ = len;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (_tmp41_ == ((glong) 2)) {
#line 1501 "filehelper.c"
						const gchar* _tmp42_ = NULL;
						gboolean _tmp43_ = FALSE;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp42_ = start;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp43_ = g_str_has_prefix (_tmp42_, "..");
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp40_ = _tmp43_;
#line 1510 "filehelper.c"
					} else {
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp40_ = FALSE;
#line 1514 "filehelper.c"
					}
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
					if (_tmp40_) {
#line 1518 "filehelper.c"
						const gchar* _tmp44_ = NULL;
						gint _tmp45_ = 0;
						gint _tmp46_ = 0;
						glong _tmp47_ = 0L;
#line 172 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp44_ = rpath;
#line 172 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp45_ = strlen (_tmp44_);
#line 172 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp46_ = _tmp45_;
#line 172 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp47_ = root_len;
#line 172 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						if (((glong) _tmp46_) > _tmp47_) {
#line 1533 "filehelper.c"
							{
								gboolean _tmp48_ = FALSE;
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
								_tmp48_ = TRUE;
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
								while (TRUE) {
#line 1540 "filehelper.c"
									const gchar* _tmp51_ = NULL;
									const gchar* _tmp52_ = NULL;
									gint _tmp53_ = 0;
									gint _tmp54_ = 0;
									gchar* _tmp55_ = NULL;
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									if (!_tmp48_) {
#line 1548 "filehelper.c"
										const gchar* _tmp49_ = NULL;
										gboolean _tmp50_ = FALSE;
#line 175 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
										_tmp49_ = rpath;
#line 175 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
										_tmp50_ = valadoc_ends_with_dir_separator (_tmp49_);
#line 175 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
										if (!(!_tmp50_)) {
#line 175 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
											break;
#line 1559 "filehelper.c"
										}
									}
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									_tmp48_ = FALSE;
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									_tmp51_ = rpath;
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									_tmp52_ = rpath;
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									_tmp53_ = strlen (_tmp52_);
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									_tmp54_ = _tmp53_;
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									_tmp55_ = string_substring (_tmp51_, (glong) 0, (glong) (_tmp54_ - 1));
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									_g_free0 (rpath);
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
									rpath = _tmp55_;
#line 1578 "filehelper.c"
								}
							}
						}
					} else {
						const gchar* _tmp56_ = NULL;
						gboolean _tmp57_ = FALSE;
						const gchar* _tmp60_ = NULL;
						const gchar* _tmp61_ = NULL;
						glong _tmp62_ = 0L;
						gchar* _tmp63_ = NULL;
						gchar* _tmp64_ = NULL;
						gchar* _tmp65_ = NULL;
#line 178 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp56_ = rpath;
#line 178 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp57_ = valadoc_ends_with_dir_separator (_tmp56_);
#line 178 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						if (!_tmp57_) {
#line 1597 "filehelper.c"
							const gchar* _tmp58_ = NULL;
							gchar* _tmp59_ = NULL;
#line 179 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_tmp58_ = rpath;
#line 179 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_tmp59_ = g_strconcat (_tmp58_, G_DIR_SEPARATOR_S, NULL);
#line 179 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							_g_free0 (rpath);
#line 179 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
							rpath = _tmp59_;
#line 1608 "filehelper.c"
						}
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp60_ = rpath;
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp61_ = start;
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp62_ = len;
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp63_ = string_substring (_tmp61_, (glong) 0, _tmp62_);
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp64_ = _tmp63_;
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_g_free0 (rpath);
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						rpath = _tmp65_;
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
						_g_free0 (_tmp64_);
#line 1628 "filehelper.c"
					}
				}
			}
		}
	}
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp67_ = rpath;
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp68_ = strlen (_tmp67_);
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp69_ = _tmp68_;
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	_tmp70_ = root_len;
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	if (((glong) _tmp69_) > _tmp70_) {
#line 1644 "filehelper.c"
		const gchar* _tmp71_ = NULL;
		gboolean _tmp72_ = FALSE;
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp71_ = rpath;
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp72_ = valadoc_ends_with_dir_separator (_tmp71_);
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp66_ = _tmp72_;
#line 1653 "filehelper.c"
	} else {
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp66_ = FALSE;
#line 1657 "filehelper.c"
	}
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	if (_tmp66_) {
#line 1661 "filehelper.c"
		const gchar* _tmp73_ = NULL;
		const gchar* _tmp74_ = NULL;
		gint _tmp75_ = 0;
		gint _tmp76_ = 0;
		gchar* _tmp77_ = NULL;
#line 187 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp73_ = rpath;
#line 187 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp74_ = rpath;
#line 187 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp75_ = strlen (_tmp74_);
#line 187 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp76_ = _tmp75_;
#line 187 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp77_ = string_substring (_tmp73_, (glong) 0, (glong) (_tmp76_ - 1));
#line 187 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_g_free0 (rpath);
#line 187 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		rpath = _tmp77_;
#line 1681 "filehelper.c"
	}
#line 190 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	if (G_DIR_SEPARATOR != '/') {
#line 1685 "filehelper.c"
		gchar** components = NULL;
		const gchar* _tmp78_ = NULL;
		gchar** _tmp79_ = NULL;
		gchar** _tmp80_ = NULL;
		gint components_length1 = 0;
		gint _components_size_ = 0;
		gchar** _tmp81_ = NULL;
		gint _tmp81__length1 = 0;
		gchar* _tmp82_ = NULL;
#line 193 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp78_ = rpath;
#line 193 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp80_ = _tmp79_ = g_strsplit (_tmp78_, "\\", 0);
#line 193 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		components = _tmp80_;
#line 193 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		components_length1 = _vala_array_length (_tmp79_);
#line 193 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_components_size_ = components_length1;
#line 194 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp81_ = components;
#line 194 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp81__length1 = components_length1;
#line 194 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_tmp82_ = _vala_g_strjoinv ("/", _tmp81_, _tmp81__length1);
#line 194 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		_g_free0 (rpath);
#line 194 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		rpath = _tmp82_;
#line 190 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
		components = (_vala_array_free (components, components_length1, (GDestroyNotify) g_free), NULL);
#line 1717 "filehelper.c"
	}
#line 197 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	result = rpath;
#line 197 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/filehelper.vala"
	return result;
#line 1723 "filehelper.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



