/* markupreader.c generated by valac 0.26.1, the Vala compiler
 * generated from markupreader.vala, do not modify */

/* markupreader.vala
 *
 * Copyright (C) 2008-2009  Jürg Billeter
 * Copyright (C) 2011       Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>


#define VALADOC_TYPE_MARKUP_READER (valadoc_markup_reader_get_type ())
#define VALADOC_MARKUP_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALADOC_TYPE_MARKUP_READER, ValadocMarkupReader))
#define VALADOC_MARKUP_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALADOC_TYPE_MARKUP_READER, ValadocMarkupReaderClass))
#define VALADOC_IS_MARKUP_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALADOC_TYPE_MARKUP_READER))
#define VALADOC_IS_MARKUP_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALADOC_TYPE_MARKUP_READER))
#define VALADOC_MARKUP_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALADOC_TYPE_MARKUP_READER, ValadocMarkupReaderClass))

typedef struct _ValadocMarkupReader ValadocMarkupReader;
typedef struct _ValadocMarkupReaderClass ValadocMarkupReaderClass;
typedef struct _ValadocMarkupReaderPrivate ValadocMarkupReaderPrivate;

#define VALADOC_TYPE_ERROR_REPORTER (valadoc_error_reporter_get_type ())
#define VALADOC_ERROR_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALADOC_TYPE_ERROR_REPORTER, ValadocErrorReporter))
#define VALADOC_ERROR_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALADOC_TYPE_ERROR_REPORTER, ValadocErrorReporterClass))
#define VALADOC_IS_ERROR_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALADOC_TYPE_ERROR_REPORTER))
#define VALADOC_IS_ERROR_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALADOC_TYPE_ERROR_REPORTER))
#define VALADOC_ERROR_REPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALADOC_TYPE_ERROR_REPORTER, ValadocErrorReporterClass))

typedef struct _ValadocErrorReporter ValadocErrorReporter;
typedef struct _ValadocErrorReporterClass ValadocErrorReporterClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_mapped_file_unref0(var) ((var == NULL) ? NULL : (var = (g_mapped_file_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define VALADOC_TYPE_MARKUP_SOURCE_LOCATION (valadoc_markup_source_location_get_type ())
typedef struct _ValadocMarkupSourceLocation ValadocMarkupSourceLocation;

#define VALADOC_TYPE_MARKUP_TOKEN_TYPE (valadoc_markup_token_type_get_type ())
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _ValadocMarkupReader {
	GObject parent_instance;
	ValadocMarkupReaderPrivate * priv;
};

struct _ValadocMarkupReaderClass {
	GObjectClass parent_class;
};

struct _ValadocMarkupReaderPrivate {
	gchar* _filename;
	gchar* _name;
	gchar* _content;
	GMappedFile* mapped_file;
	gchar** lines;
	gint lines_length1;
	gint _lines_size_;
	gchar* begin;
	gchar* current;
	gchar* end;
	gint line;
	gint column;
	GeeMap* attributes;
	gboolean empty_element;
	ValadocErrorReporter* reporter;
};

struct _ValadocMarkupSourceLocation {
	gchar* pos;
	gint line;
	gint column;
};

typedef enum  {
	VALADOC_MARKUP_TOKEN_TYPE_NONE,
	VALADOC_MARKUP_TOKEN_TYPE_COMMENT,
	VALADOC_MARKUP_TOKEN_TYPE_START_ELEMENT,
	VALADOC_MARKUP_TOKEN_TYPE_END_ELEMENT,
	VALADOC_MARKUP_TOKEN_TYPE_TEXT,
	VALADOC_MARKUP_TOKEN_TYPE_EOF
} ValadocMarkupTokenType;


static gpointer valadoc_markup_reader_parent_class = NULL;

GType valadoc_markup_reader_get_type (void) G_GNUC_CONST;
GType valadoc_error_reporter_get_type (void) G_GNUC_CONST;
#define VALADOC_MARKUP_READER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_TYPE_MARKUP_READER, ValadocMarkupReaderPrivate))
enum  {
	VALADOC_MARKUP_READER_DUMMY_PROPERTY,
	VALADOC_MARKUP_READER_FILENAME,
	VALADOC_MARKUP_READER_NAME,
	VALADOC_MARKUP_READER_CONTENT
};
ValadocMarkupReader* valadoc_markup_reader_new_from_string (const gchar* filename, const gchar* content, ValadocErrorReporter* reporter);
ValadocMarkupReader* valadoc_markup_reader_construct_from_string (GType object_type, const gchar* filename, const gchar* content, ValadocErrorReporter* reporter);
static void valadoc_markup_reader_set_filename (ValadocMarkupReader* self, const gchar* value);
ValadocMarkupReader* valadoc_markup_reader_new (const gchar* filename, ValadocErrorReporter* reporter);
ValadocMarkupReader* valadoc_markup_reader_construct (GType object_type, const gchar* filename, ValadocErrorReporter* reporter);
void valadoc_error_reporter_simple_error (ValadocErrorReporter* self, const gchar* location, const gchar* msg_format, ...);
gchar* valadoc_markup_reader_get_line_content (ValadocMarkupReader* self, gint line_nr);
gchar* valadoc_markup_reader_get_attribute (ValadocMarkupReader* self, const gchar* attr);
GeeMap* valadoc_markup_reader_get_attributes (ValadocMarkupReader* self);
static gchar* valadoc_markup_reader_read_name (ValadocMarkupReader* self);
const gchar* valadoc_markup_reader_get_filename (ValadocMarkupReader* self);
GType valadoc_markup_source_location_get_type (void) G_GNUC_CONST;
ValadocMarkupSourceLocation* valadoc_markup_source_location_dup (const ValadocMarkupSourceLocation* self);
void valadoc_markup_source_location_free (ValadocMarkupSourceLocation* self);
GType valadoc_markup_token_type_get_type (void) G_GNUC_CONST;
ValadocMarkupTokenType valadoc_markup_reader_read_token (ValadocMarkupReader* self, ValadocMarkupSourceLocation* token_begin, ValadocMarkupSourceLocation* token_end);
void valadoc_markup_source_location_init (ValadocMarkupSourceLocation *self, gchar* _pos, gint _line, gint _column);
static void valadoc_markup_reader_set_content (ValadocMarkupReader* self, const gchar* value);
static void valadoc_markup_reader_set_name (ValadocMarkupReader* self, const gchar* value);
static void valadoc_markup_reader_space (ValadocMarkupReader* self);
static gchar* valadoc_markup_reader_text (ValadocMarkupReader* self, gchar end_char, gboolean rm_trailing_whitespace);
const gchar* valadoc_markup_reader_get_name (ValadocMarkupReader* self);
const gchar* valadoc_markup_reader_get_content (ValadocMarkupReader* self);
static void valadoc_markup_reader_finalize (GObject* obj);
static void _vala_valadoc_markup_reader_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_valadoc_markup_reader_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gpointer _g_object_ref0 (gpointer self) {
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return self ? g_object_ref (self) : NULL;
#line 154 "markupreader.c"
}


ValadocMarkupReader* valadoc_markup_reader_construct_from_string (GType object_type, const gchar* filename, const gchar* content, ValadocErrorReporter* reporter) {
	ValadocMarkupReader * self = NULL;
	const gchar* _tmp0_ = NULL;
	ValadocErrorReporter* _tmp1_ = NULL;
	ValadocErrorReporter* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	gchar** _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	gchar* _tmp11_ = NULL;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (content != NULL, NULL);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (reporter != NULL, NULL);
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self = (ValadocMarkupReader*) g_object_new (object_type, NULL);
#line 63 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = filename;
#line 63 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	valadoc_markup_reader_set_filename (self, _tmp0_);
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = reporter;
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_object_unref0 (self->priv->reporter);
#line 64 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->reporter = _tmp2_;
#line 66 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp3_ = content;
#line 66 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp5_ = _tmp4_ = g_strsplit (_tmp3_, "\n", 0);
#line 66 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->lines = (_vala_array_free (self->priv->lines, self->priv->lines_length1, (GDestroyNotify) g_free), NULL);
#line 66 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->lines = _tmp5_;
#line 66 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->lines_length1 = _vala_array_length (_tmp4_);
#line 66 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->_lines_size_ = self->priv->lines_length1;
#line 67 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp6_ = content;
#line 67 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->begin = _tmp6_;
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp7_ = self->priv->begin;
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp8_ = content;
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp9_ = strlen (_tmp8_);
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp10_ = _tmp9_;
#line 68 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->end = _tmp7_ + _tmp10_;
#line 69 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp11_ = self->priv->begin;
#line 69 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->current = _tmp11_;
#line 71 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->column = 1;
#line 72 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->line = 1;
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return self;
#line 228 "markupreader.c"
}


ValadocMarkupReader* valadoc_markup_reader_new_from_string (const gchar* filename, const gchar* content, ValadocErrorReporter* reporter) {
#line 62 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return valadoc_markup_reader_construct_from_string (VALADOC_TYPE_MARKUP_READER, filename, content, reporter);
#line 235 "markupreader.c"
}


ValadocMarkupReader* valadoc_markup_reader_construct (GType object_type, const gchar* filename, ValadocErrorReporter* reporter) {
	ValadocMarkupReader * self = NULL;
	const gchar* _tmp0_ = NULL;
	ValadocErrorReporter* _tmp1_ = NULL;
	ValadocErrorReporter* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
#line 75 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (filename != NULL, NULL);
#line 75 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (reporter != NULL, NULL);
#line 75 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self = (ValadocMarkupReader*) g_object_new (object_type, NULL);
#line 76 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = filename;
#line 76 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	valadoc_markup_reader_set_filename (self, _tmp0_);
#line 77 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = reporter;
#line 77 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 77 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_object_unref0 (self->priv->reporter);
#line 77 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->reporter = _tmp2_;
#line 263 "markupreader.c"
	{
		GMappedFile* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		GMappedFile* _tmp5_ = NULL;
		GMappedFile* _tmp6_ = NULL;
		GMappedFile* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gchar** _tmp10_ = NULL;
		gchar** _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
		GMappedFile* _tmp13_ = NULL;
		gsize _tmp14_ = 0UL;
		gchar* _tmp15_ = NULL;
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp4_ = filename;
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp5_ = g_mapped_file_new (_tmp4_, FALSE, &_inner_error_);
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp3_ = _tmp5_;
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			if (_inner_error_->domain == G_FILE_ERROR) {
#line 288 "markupreader.c"
				goto __catch4_g_file_error;
			}
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			g_clear_error (&_inner_error_);
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			return NULL;
#line 297 "markupreader.c"
		}
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp6_ = _tmp3_;
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp3_ = NULL;
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_g_mapped_file_unref0 (self->priv->mapped_file);
#line 80 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->mapped_file = _tmp6_;
#line 81 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp7_ = self->priv->mapped_file;
#line 81 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp8_ = g_mapped_file_get_contents (_tmp7_);
#line 81 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->begin = _tmp8_;
#line 82 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp9_ = self->priv->begin;
#line 82 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp11_ = _tmp10_ = g_strsplit ((const gchar*) _tmp9_, "\n", 0);
#line 82 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->lines = (_vala_array_free (self->priv->lines, self->priv->lines_length1, (GDestroyNotify) g_free), NULL);
#line 82 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->lines = _tmp11_;
#line 82 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->lines_length1 = _vala_array_length (_tmp10_);
#line 82 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->_lines_size_ = self->priv->lines_length1;
#line 83 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp12_ = self->priv->begin;
#line 83 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp13_ = self->priv->mapped_file;
#line 83 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp14_ = g_mapped_file_get_length (_tmp13_);
#line 83 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->end = _tmp12_ + _tmp14_;
#line 85 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp15_ = self->priv->begin;
#line 85 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->current = _tmp15_;
#line 87 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->line = 1;
#line 88 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->column = 1;
#line 79 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_g_mapped_file_unref0 (_tmp3_);
#line 343 "markupreader.c"
	}
	goto __finally4;
	__catch4_g_file_error:
	{
		GError* e = NULL;
		ValadocErrorReporter* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		GError* _tmp18_ = NULL;
		const gchar* _tmp19_ = NULL;
#line 79 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		e = _inner_error_;
#line 79 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_inner_error_ = NULL;
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp16_ = reporter;
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp17_ = filename;
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp18_ = e;
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp19_ = _tmp18_->message;
#line 90 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		valadoc_error_reporter_simple_error (_tmp16_, NULL, "Unable to map file '%s': %s", _tmp17_, _tmp19_, NULL);
#line 79 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_g_error_free0 (e);
#line 369 "markupreader.c"
	}
	__finally4:
#line 79 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 79 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 79 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		g_clear_error (&_inner_error_);
#line 79 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		return NULL;
#line 380 "markupreader.c"
	}
#line 75 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return self;
#line 384 "markupreader.c"
}


ValadocMarkupReader* valadoc_markup_reader_new (const gchar* filename, ValadocErrorReporter* reporter) {
#line 75 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return valadoc_markup_reader_construct (VALADOC_TYPE_MARKUP_READER, filename, reporter);
#line 391 "markupreader.c"
}


gchar* valadoc_markup_reader_get_line_content (ValadocMarkupReader* self, gint line_nr) {
	gchar* result = NULL;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	gint _tmp1_ = 0;
#line 94 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 95 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = self->priv->lines;
#line 95 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0__length1 = self->priv->lines_length1;
#line 95 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = line_nr;
#line 95 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (_tmp0__length1 > _tmp1_) {
#line 410 "markupreader.c"
		gchar** _tmp2_ = NULL;
		gint _tmp2__length1 = 0;
		gint _tmp3_ = 0;
		const gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
#line 96 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp2_ = self->priv->lines;
#line 96 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp2__length1 = self->priv->lines_length1;
#line 96 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp3_ = line_nr;
#line 96 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp4_ = _tmp2_[_tmp3_];
#line 96 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 96 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		result = _tmp5_;
#line 96 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		return result;
#line 430 "markupreader.c"
	}
#line 99 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = NULL;
#line 99 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 436 "markupreader.c"
}


gchar* valadoc_markup_reader_get_attribute (ValadocMarkupReader* self, const gchar* attr) {
	gchar* result = NULL;
	GeeMap* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
#line 102 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (attr != NULL, NULL);
#line 103 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = self->priv->attributes;
#line 103 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = attr;
#line 103 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp2_ = gee_map_get (_tmp0_, _tmp1_);
#line 103 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = (gchar*) _tmp2_;
#line 103 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 459 "markupreader.c"
}


GeeMap* valadoc_markup_reader_get_attributes (ValadocMarkupReader* self) {
	GeeMap* result = NULL;
	GeeHashMap* _result_ = NULL;
	GeeHashMap* _tmp0_ = NULL;
#line 111 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 112 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_result_ = _tmp0_;
#line 473 "markupreader.c"
	{
		GeeIterator* _key_it = NULL;
		GeeMap* _tmp1_ = NULL;
		GeeSet* _tmp2_ = NULL;
		GeeSet* _tmp3_ = NULL;
		GeeSet* _tmp4_ = NULL;
		GeeIterator* _tmp5_ = NULL;
		GeeIterator* _tmp6_ = NULL;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp1_ = self->priv->attributes;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp2_ = gee_map_get_keys (_tmp1_);
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp3_ = _tmp2_;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp4_ = _tmp3_;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp6_ = _tmp5_;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_g_object_unref0 (_tmp4_);
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_key_it = _tmp6_;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		while (TRUE) {
#line 500 "markupreader.c"
			GeeIterator* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			gchar* key = NULL;
			GeeIterator* _tmp9_ = NULL;
			gpointer _tmp10_ = NULL;
			GeeHashMap* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			GeeMap* _tmp13_ = NULL;
			const gchar* _tmp14_ = NULL;
			gpointer _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp7_ = _key_it;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp8_ = gee_iterator_next (_tmp7_);
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			if (!_tmp8_) {
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				break;
#line 520 "markupreader.c"
			}
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp9_ = _key_it;
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp10_ = gee_iterator_get (_tmp9_);
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			key = (gchar*) _tmp10_;
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp11_ = _result_;
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp12_ = key;
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp13_ = self->priv->attributes;
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp14_ = key;
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp15_ = gee_map_get (_tmp13_, _tmp14_);
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp16_ = (gchar*) _tmp15_;
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, _tmp12_, _tmp16_);
#line 114 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_g_free0 (_tmp16_);
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_g_free0 (key);
#line 546 "markupreader.c"
		}
#line 113 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_g_object_unref0 (_key_it);
#line 550 "markupreader.c"
	}
#line 116 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = (GeeMap*) _result_;
#line 116 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 556 "markupreader.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1197 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1197 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1197 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1197 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1198 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1198 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 579 "markupreader.c"
		glong _tmp4_ = 0L;
#line 1199 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1199 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1199 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 587 "markupreader.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1201 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1201 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1201 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1201 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		return result;
#line 599 "markupreader.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1208 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 623 "markupreader.c"
		glong _tmp2_ = 0L;
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 629 "markupreader.c"
	} else {
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 633 "markupreader.c"
	}
#line 1210 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 637 "markupreader.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1212 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1212 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1212 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1212 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 649 "markupreader.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1214 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1214 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1214 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 659 "markupreader.c"
	}
#line 1217 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1217 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 665 "markupreader.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1218 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1218 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1218 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1219 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1219 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 679 "markupreader.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1221 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1221 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1221 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 689 "markupreader.c"
	}
#line 1223 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1223 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 695 "markupreader.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1224 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1224 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1224 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 704 "markupreader.c"
	}
#line 1226 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1226 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1226 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1226 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1227 "/usr/share/vala-0.26/vapi/glib-2.0.vapi"
	return result;
#line 724 "markupreader.c"
}


static gchar* valadoc_markup_reader_read_name (ValadocMarkupReader* self) {
	gchar* result = NULL;
	gchar* begin = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	gchar* _tmp36_ = NULL;
	gchar* _tmp37_ = NULL;
	gchar* _tmp38_ = NULL;
#line 119 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = self->priv->current;
#line 120 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	begin = _tmp0_;
#line 121 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	while (TRUE) {
#line 746 "markupreader.c"
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		gchar* _tmp8_ = NULL;
		gchar _tmp9_ = '\0';
		gunichar u = 0U;
		gchar* _tmp20_ = NULL;
		gchar* _tmp21_ = NULL;
		gchar* _tmp22_ = NULL;
		gunichar _tmp23_ = 0U;
		gunichar _tmp24_ = 0U;
#line 121 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp1_ = self->priv->current;
#line 121 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp2_ = self->priv->end;
#line 121 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (!(_tmp1_ < _tmp2_)) {
#line 121 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			break;
#line 770 "markupreader.c"
		}
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp8_ = self->priv->current;
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp9_ = _tmp8_[0];
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp9_ == ' ') {
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp7_ = TRUE;
#line 780 "markupreader.c"
		} else {
			gchar* _tmp10_ = NULL;
			gchar _tmp11_ = '\0';
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp10_ = self->priv->current;
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp11_ = _tmp10_[0];
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp7_ = _tmp11_ == '\t';
#line 790 "markupreader.c"
		}
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp7_) {
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp6_ = TRUE;
#line 796 "markupreader.c"
		} else {
			gchar* _tmp12_ = NULL;
			gchar _tmp13_ = '\0';
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp12_ = self->priv->current;
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp13_ = _tmp12_[0];
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp6_ = _tmp13_ == '>';
#line 806 "markupreader.c"
		}
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp6_) {
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp5_ = TRUE;
#line 812 "markupreader.c"
		} else {
			gchar* _tmp14_ = NULL;
			gchar _tmp15_ = '\0';
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp14_ = self->priv->current;
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp15_ = _tmp14_[0];
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp5_ = _tmp15_ == '/';
#line 822 "markupreader.c"
		}
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp5_) {
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp4_ = TRUE;
#line 828 "markupreader.c"
		} else {
			gchar* _tmp16_ = NULL;
			gchar _tmp17_ = '\0';
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp16_ = self->priv->current;
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp17_ = _tmp16_[0];
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp4_ = _tmp17_ == '=';
#line 838 "markupreader.c"
		}
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp4_) {
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp3_ = TRUE;
#line 844 "markupreader.c"
		} else {
			gchar* _tmp18_ = NULL;
			gchar _tmp19_ = '\0';
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp18_ = self->priv->current;
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp19_ = _tmp18_[0];
#line 123 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp3_ = _tmp19_ == '\n';
#line 854 "markupreader.c"
		}
#line 122 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp3_) {
#line 124 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			break;
#line 860 "markupreader.c"
		}
#line 126 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp20_ = self->priv->current;
#line 126 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp21_ = self->priv->end;
#line 126 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp22_ = self->priv->current;
#line 126 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp23_ = g_utf8_get_char_validated ((const gchar*) _tmp20_, (gssize) ((glong) (_tmp21_ - _tmp22_)));
#line 126 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		u = _tmp23_;
#line 127 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp24_ = u;
#line 127 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp24_ != ((gunichar) (-1))) {
#line 876 "markupreader.c"
			gchar* _tmp25_ = NULL;
			gunichar _tmp26_ = 0U;
			gint _tmp27_ = 0;
#line 128 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp25_ = self->priv->current;
#line 128 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp26_ = u;
#line 128 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp27_ = g_unichar_to_utf8 (_tmp26_, NULL);
#line 128 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			self->priv->current = _tmp25_ + _tmp27_;
#line 888 "markupreader.c"
		} else {
			ValadocErrorReporter* _tmp28_ = NULL;
			const gchar* _tmp29_ = NULL;
			gint _tmp30_ = 0;
			gchar* _tmp31_ = NULL;
			gchar* _tmp32_ = NULL;
#line 130 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp28_ = self->priv->reporter;
#line 130 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp29_ = self->priv->_filename;
#line 130 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp30_ = self->priv->line;
#line 130 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp31_ = g_strdup_printf ("%s:%d", _tmp29_, _tmp30_);
#line 130 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp32_ = _tmp31_;
#line 130 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			valadoc_error_reporter_simple_error (_tmp28_, _tmp32_, "invalid UTF-8 character", NULL);
#line 130 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_g_free0 (_tmp32_);
#line 909 "markupreader.c"
		}
	}
#line 134 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp33_ = self->priv->current;
#line 134 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp34_ = begin;
#line 134 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (_tmp33_ == _tmp34_) {
#line 918 "markupreader.c"
	}
#line 137 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp35_ = begin;
#line 137 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp36_ = self->priv->current;
#line 137 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp37_ = begin;
#line 137 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp38_ = string_substring ((const gchar*) _tmp35_, (glong) 0, (glong) ((gint) (_tmp36_ - _tmp37_)));
#line 137 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = _tmp38_;
#line 137 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 932 "markupreader.c"
}


ValadocMarkupTokenType valadoc_markup_reader_read_token (ValadocMarkupReader* self, ValadocMarkupSourceLocation* token_begin, ValadocMarkupSourceLocation* token_end) {
	ValadocMarkupSourceLocation _vala_token_begin = {0};
	ValadocMarkupSourceLocation _vala_token_end = {0};
	ValadocMarkupTokenType result = 0;
	GeeMap* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	ValadocMarkupTokenType type = 0;
	gchar* begin = NULL;
	gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gint _tmp10_ = 0;
	gint _tmp11_ = 0;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp111_ = NULL;
	gint _tmp112_ = 0;
	gint _tmp113_ = 0;
#line 140 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 141 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = self->priv->attributes;
#line 141 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	gee_map_clear (_tmp0_);
#line 143 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = self->priv->empty_element;
#line 143 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (_tmp1_) {
#line 963 "markupreader.c"
		gchar* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 144 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->empty_element = FALSE;
#line 145 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp2_ = self->priv->begin;
#line 145 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp3_ = self->priv->line;
#line 145 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp4_ = self->priv->column;
#line 145 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		valadoc_markup_source_location_init (&_vala_token_begin, _tmp2_, _tmp3_, _tmp4_);
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp5_ = self->priv->begin;
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp6_ = self->priv->line;
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp7_ = self->priv->column;
#line 146 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		valadoc_markup_source_location_init (&_vala_token_end, _tmp5_, _tmp6_, _tmp7_);
#line 147 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		result = VALADOC_MARKUP_TOKEN_TYPE_END_ELEMENT;
#line 147 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (token_begin) {
#line 147 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			*token_begin = _vala_token_begin;
#line 994 "markupreader.c"
		}
#line 147 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (token_end) {
#line 147 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			*token_end = _vala_token_end;
#line 1000 "markupreader.c"
		}
#line 147 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		return result;
#line 1004 "markupreader.c"
	}
#line 150 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	valadoc_markup_reader_set_content (self, NULL);
#line 151 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	valadoc_markup_reader_set_name (self, NULL);
#line 153 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	valadoc_markup_reader_space (self);
#line 155 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	type = VALADOC_MARKUP_TOKEN_TYPE_NONE;
#line 156 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp8_ = self->priv->current;
#line 156 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	begin = _tmp8_;
#line 157 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp9_ = begin;
#line 157 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp10_ = self->priv->line;
#line 157 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp11_ = self->priv->column;
#line 157 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	valadoc_markup_source_location_init (&_vala_token_begin, _tmp9_, _tmp10_, _tmp11_);
#line 159 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp12_ = self->priv->current;
#line 159 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp13_ = self->priv->end;
#line 159 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (_tmp12_ >= _tmp13_) {
#line 160 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		type = VALADOC_MARKUP_TOKEN_TYPE_EOF;
#line 1034 "markupreader.c"
	} else {
		gchar* _tmp14_ = NULL;
		gchar _tmp15_ = '\0';
#line 161 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp14_ = self->priv->current;
#line 161 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp15_ = _tmp14_[0];
#line 161 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp15_ == '<') {
#line 1044 "markupreader.c"
			gchar* _tmp16_ = NULL;
			gchar* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp16_ = self->priv->current;
#line 162 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			self->priv->current = _tmp16_ + 1;
#line 163 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp17_ = self->priv->current;
#line 163 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp18_ = self->priv->end;
#line 163 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			if (_tmp17_ >= _tmp18_) {
#line 1058 "markupreader.c"
			} else {
				gchar* _tmp19_ = NULL;
				gchar _tmp20_ = '\0';
#line 165 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp19_ = self->priv->current;
#line 165 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp20_ = _tmp19_[0];
#line 165 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				if (_tmp20_ == '?') {
#line 1068 "markupreader.c"
				} else {
					gchar* _tmp21_ = NULL;
					gchar _tmp22_ = '\0';
#line 167 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp21_ = self->priv->current;
#line 167 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp22_ = _tmp21_[0];
#line 167 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					if (_tmp22_ == '!') {
#line 1078 "markupreader.c"
						gchar* _tmp23_ = NULL;
						gboolean _tmp24_ = FALSE;
						gboolean _tmp25_ = FALSE;
						gchar* _tmp26_ = NULL;
						gchar* _tmp27_ = NULL;
#line 169 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp23_ = self->priv->current;
#line 169 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						self->priv->current = _tmp23_ + 1;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp26_ = self->priv->current;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp27_ = self->priv->end;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						if (_tmp26_ < (_tmp27_ - 1)) {
#line 1094 "markupreader.c"
							gchar* _tmp28_ = NULL;
							gchar _tmp29_ = '\0';
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp28_ = self->priv->current;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp29_ = _tmp28_[0];
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp25_ = _tmp29_ == '-';
#line 1103 "markupreader.c"
						} else {
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp25_ = FALSE;
#line 1107 "markupreader.c"
						}
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						if (_tmp25_) {
#line 1111 "markupreader.c"
							gchar* _tmp30_ = NULL;
							gchar _tmp31_ = '\0';
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp30_ = self->priv->current;
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp31_ = _tmp30_[1];
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp24_ = _tmp31_ == '-';
#line 1120 "markupreader.c"
						} else {
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp24_ = FALSE;
#line 1124 "markupreader.c"
						}
#line 170 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						if (_tmp24_) {
#line 1128 "markupreader.c"
							gchar* _tmp32_ = NULL;
							ValadocMarkupSourceLocation _tmp48_ = {0};
							ValadocMarkupSourceLocation _tmp49_ = {0};
							ValadocMarkupTokenType _tmp50_ = 0;
#line 172 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp32_ = self->priv->current;
#line 172 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							self->priv->current = _tmp32_ + 2;
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							while (TRUE) {
#line 1139 "markupreader.c"
								gchar* _tmp33_ = NULL;
								gchar* _tmp34_ = NULL;
								gboolean _tmp35_ = FALSE;
								gboolean _tmp36_ = FALSE;
								gchar* _tmp37_ = NULL;
								gchar _tmp38_ = '\0';
								gchar* _tmp47_ = NULL;
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp33_ = self->priv->current;
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp34_ = self->priv->end;
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (!(_tmp33_ < (_tmp34_ - 2))) {
#line 173 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									break;
#line 1155 "markupreader.c"
								}
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp37_ = self->priv->current;
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp38_ = _tmp37_[0];
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp38_ == '-') {
#line 1163 "markupreader.c"
									gchar* _tmp39_ = NULL;
									gchar _tmp40_ = '\0';
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp39_ = self->priv->current;
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp40_ = _tmp39_[1];
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp36_ = _tmp40_ == '-';
#line 1172 "markupreader.c"
								} else {
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp36_ = FALSE;
#line 1176 "markupreader.c"
								}
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp36_) {
#line 1180 "markupreader.c"
									gchar* _tmp41_ = NULL;
									gchar _tmp42_ = '\0';
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp41_ = self->priv->current;
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp42_ = _tmp41_[2];
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp35_ = _tmp42_ == '>';
#line 1189 "markupreader.c"
								} else {
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp35_ = FALSE;
#line 1193 "markupreader.c"
								}
#line 174 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp35_) {
#line 1197 "markupreader.c"
									gchar* _tmp43_ = NULL;
#line 176 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp43_ = self->priv->current;
#line 176 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									self->priv->current = _tmp43_ + 3;
#line 177 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									break;
#line 1205 "markupreader.c"
								} else {
									gchar* _tmp44_ = NULL;
									gchar _tmp45_ = '\0';
#line 178 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp44_ = self->priv->current;
#line 178 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp45_ = _tmp44_[0];
#line 178 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									if (_tmp45_ == '\n') {
#line 1215 "markupreader.c"
										gint _tmp46_ = 0;
#line 179 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp46_ = self->priv->line;
#line 179 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										self->priv->line = _tmp46_ + 1;
#line 180 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										self->priv->column = 0;
#line 1223 "markupreader.c"
									}
								}
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp47_ = self->priv->current;
#line 182 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								self->priv->current = _tmp47_ + 1;
#line 1230 "markupreader.c"
							}
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp50_ = valadoc_markup_reader_read_token (self, &_tmp48_, &_tmp49_);
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_vala_token_begin = _tmp48_;
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_vala_token_end = _tmp49_;
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							result = _tmp50_;
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							if (token_begin) {
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								*token_begin = _vala_token_begin;
#line 1244 "markupreader.c"
							}
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							if (token_end) {
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								*token_end = _vala_token_end;
#line 1250 "markupreader.c"
							}
#line 186 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							return result;
#line 1254 "markupreader.c"
						}
					} else {
						gchar* _tmp51_ = NULL;
						gchar _tmp52_ = '\0';
#line 188 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp51_ = self->priv->current;
#line 188 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp52_ = _tmp51_[0];
#line 188 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						if (_tmp52_ == '/') {
#line 1265 "markupreader.c"
							gchar* _tmp53_ = NULL;
							gchar* _tmp54_ = NULL;
							gchar* _tmp55_ = NULL;
							gboolean _tmp56_ = FALSE;
							gchar* _tmp57_ = NULL;
							gchar* _tmp58_ = NULL;
							gchar* _tmp61_ = NULL;
#line 189 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							type = VALADOC_MARKUP_TOKEN_TYPE_END_ELEMENT;
#line 190 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp53_ = self->priv->current;
#line 190 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							self->priv->current = _tmp53_ + 1;
#line 191 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp54_ = valadoc_markup_reader_read_name (self);
#line 191 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp55_ = _tmp54_;
#line 191 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							valadoc_markup_reader_set_name (self, _tmp55_);
#line 191 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_g_free0 (_tmp55_);
#line 192 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp57_ = self->priv->current;
#line 192 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp58_ = self->priv->end;
#line 192 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							if (_tmp57_ >= _tmp58_) {
#line 192 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp56_ = TRUE;
#line 1295 "markupreader.c"
							} else {
								gchar* _tmp59_ = NULL;
								gchar _tmp60_ = '\0';
#line 192 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp59_ = self->priv->current;
#line 192 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp60_ = _tmp59_[0];
#line 192 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp56_ = _tmp60_ != '>';
#line 1305 "markupreader.c"
							}
#line 192 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							if (_tmp56_) {
#line 1309 "markupreader.c"
							}
#line 195 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp61_ = self->priv->current;
#line 195 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							self->priv->current = _tmp61_ + 1;
#line 1315 "markupreader.c"
						} else {
							gchar* _tmp62_ = NULL;
							gchar* _tmp63_ = NULL;
							gchar* _tmp95_ = NULL;
							gchar _tmp96_ = '\0';
							gboolean _tmp98_ = FALSE;
							gchar* _tmp99_ = NULL;
							gchar* _tmp100_ = NULL;
							gchar* _tmp103_ = NULL;
#line 197 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							type = VALADOC_MARKUP_TOKEN_TYPE_START_ELEMENT;
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp62_ = valadoc_markup_reader_read_name (self);
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp63_ = _tmp62_;
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							valadoc_markup_reader_set_name (self, _tmp63_);
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_g_free0 (_tmp63_);
#line 199 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							valadoc_markup_reader_space (self);
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							while (TRUE) {
#line 1339 "markupreader.c"
								gboolean _tmp64_ = FALSE;
								gboolean _tmp65_ = FALSE;
								gchar* _tmp66_ = NULL;
								gchar* _tmp67_ = NULL;
								gchar* attr_name = NULL;
								gchar* _tmp72_ = NULL;
								gboolean _tmp73_ = FALSE;
								gchar* _tmp74_ = NULL;
								gchar* _tmp75_ = NULL;
								gchar* _tmp78_ = NULL;
								gboolean _tmp79_ = FALSE;
								gchar* _tmp80_ = NULL;
								gchar* _tmp81_ = NULL;
								gchar* _tmp84_ = NULL;
								gchar* attr_value = NULL;
								gchar* _tmp85_ = NULL;
								gboolean _tmp86_ = FALSE;
								gchar* _tmp87_ = NULL;
								gchar* _tmp88_ = NULL;
								gchar* _tmp91_ = NULL;
								GeeMap* _tmp92_ = NULL;
								const gchar* _tmp93_ = NULL;
								const gchar* _tmp94_ = NULL;
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp66_ = self->priv->current;
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp67_ = self->priv->end;
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp66_ < _tmp67_) {
#line 1369 "markupreader.c"
									gchar* _tmp68_ = NULL;
									gchar _tmp69_ = '\0';
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp68_ = self->priv->current;
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp69_ = _tmp68_[0];
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp65_ = _tmp69_ != '>';
#line 1378 "markupreader.c"
								} else {
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp65_ = FALSE;
#line 1382 "markupreader.c"
								}
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp65_) {
#line 1386 "markupreader.c"
									gchar* _tmp70_ = NULL;
									gchar _tmp71_ = '\0';
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp70_ = self->priv->current;
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp71_ = _tmp70_[0];
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp64_ = _tmp71_ != '/';
#line 1395 "markupreader.c"
								} else {
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp64_ = FALSE;
#line 1399 "markupreader.c"
								}
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (!_tmp64_) {
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									break;
#line 1405 "markupreader.c"
								}
#line 201 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp72_ = valadoc_markup_reader_read_name (self);
#line 201 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								attr_name = _tmp72_;
#line 202 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp74_ = self->priv->current;
#line 202 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp75_ = self->priv->end;
#line 202 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp74_ >= _tmp75_) {
#line 202 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp73_ = TRUE;
#line 1419 "markupreader.c"
								} else {
									gchar* _tmp76_ = NULL;
									gchar _tmp77_ = '\0';
#line 202 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp76_ = self->priv->current;
#line 202 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp77_ = _tmp76_[0];
#line 202 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp73_ = _tmp77_ != '=';
#line 1429 "markupreader.c"
								}
#line 202 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp73_) {
#line 1433 "markupreader.c"
								}
#line 205 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp78_ = self->priv->current;
#line 205 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								self->priv->current = _tmp78_ + 1;
#line 207 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp80_ = self->priv->current;
#line 207 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp81_ = self->priv->end;
#line 207 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp80_ >= _tmp81_) {
#line 207 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp79_ = TRUE;
#line 1447 "markupreader.c"
								} else {
									gchar* _tmp82_ = NULL;
									gchar _tmp83_ = '\0';
#line 207 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp82_ = self->priv->current;
#line 207 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp83_ = _tmp82_[0];
#line 207 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp79_ = _tmp83_ != '"';
#line 1457 "markupreader.c"
								}
#line 207 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp79_) {
#line 1461 "markupreader.c"
								}
#line 210 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp84_ = self->priv->current;
#line 210 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								self->priv->current = _tmp84_ + 1;
#line 212 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp85_ = valadoc_markup_reader_text (self, '"', FALSE);
#line 212 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								attr_value = _tmp85_;
#line 214 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp87_ = self->priv->current;
#line 214 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp88_ = self->priv->end;
#line 214 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp87_ >= _tmp88_) {
#line 214 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp86_ = TRUE;
#line 1479 "markupreader.c"
								} else {
									gchar* _tmp89_ = NULL;
									gchar _tmp90_ = '\0';
#line 214 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp89_ = self->priv->current;
#line 214 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp90_ = _tmp89_[0];
#line 214 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp86_ = _tmp90_ != '"';
#line 1489 "markupreader.c"
								}
#line 214 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp86_) {
#line 1493 "markupreader.c"
								}
#line 217 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp91_ = self->priv->current;
#line 217 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								self->priv->current = _tmp91_ + 1;
#line 218 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp92_ = self->priv->attributes;
#line 218 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp93_ = attr_name;
#line 218 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp94_ = attr_value;
#line 218 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								gee_map_set (_tmp92_, _tmp93_, _tmp94_);
#line 219 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								valadoc_markup_reader_space (self);
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_g_free0 (attr_value);
#line 200 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_g_free0 (attr_name);
#line 1513 "markupreader.c"
							}
#line 221 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp95_ = self->priv->current;
#line 221 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp96_ = _tmp95_[0];
#line 221 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							if (_tmp96_ == '/') {
#line 1521 "markupreader.c"
								gchar* _tmp97_ = NULL;
#line 222 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								self->priv->empty_element = TRUE;
#line 223 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp97_ = self->priv->current;
#line 223 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								self->priv->current = _tmp97_ + 1;
#line 224 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								valadoc_markup_reader_space (self);
#line 1531 "markupreader.c"
							} else {
#line 226 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								self->priv->empty_element = FALSE;
#line 1535 "markupreader.c"
							}
#line 228 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp99_ = self->priv->current;
#line 228 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp100_ = self->priv->end;
#line 228 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							if (_tmp99_ >= _tmp100_) {
#line 228 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp98_ = TRUE;
#line 1545 "markupreader.c"
							} else {
								gchar* _tmp101_ = NULL;
								gchar _tmp102_ = '\0';
#line 228 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp101_ = self->priv->current;
#line 228 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp102_ = _tmp101_[0];
#line 228 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp98_ = _tmp102_ != '>';
#line 1555 "markupreader.c"
							}
#line 228 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							if (_tmp98_) {
#line 1559 "markupreader.c"
							}
#line 231 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp103_ = self->priv->current;
#line 231 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							self->priv->current = _tmp103_ + 1;
#line 1565 "markupreader.c"
						}
					}
				}
			}
		} else {
			gchar* _tmp104_ = NULL;
			gchar _tmp105_ = '\0';
#line 234 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			valadoc_markup_reader_space (self);
#line 236 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp104_ = self->priv->current;
#line 236 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp105_ = _tmp104_[0];
#line 236 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			if (_tmp105_ != '<') {
#line 1581 "markupreader.c"
				gchar* _tmp106_ = NULL;
				gchar* _tmp107_ = NULL;
#line 237 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp106_ = valadoc_markup_reader_text (self, '<', TRUE);
#line 237 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp107_ = _tmp106_;
#line 237 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				valadoc_markup_reader_set_content (self, _tmp107_);
#line 237 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_g_free0 (_tmp107_);
#line 1592 "markupreader.c"
			} else {
				ValadocMarkupSourceLocation _tmp108_ = {0};
				ValadocMarkupSourceLocation _tmp109_ = {0};
				ValadocMarkupTokenType _tmp110_ = 0;
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp110_ = valadoc_markup_reader_read_token (self, &_tmp108_, &_tmp109_);
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_vala_token_begin = _tmp108_;
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_vala_token_end = _tmp109_;
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				result = _tmp110_;
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				if (token_begin) {
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					*token_begin = _vala_token_begin;
#line 1609 "markupreader.c"
				}
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				if (token_end) {
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					*token_end = _vala_token_end;
#line 1615 "markupreader.c"
				}
#line 241 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				return result;
#line 1619 "markupreader.c"
			}
#line 244 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			type = VALADOC_MARKUP_TOKEN_TYPE_TEXT;
#line 1623 "markupreader.c"
		}
	}
#line 247 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp111_ = self->priv->current;
#line 247 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp112_ = self->priv->line;
#line 247 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp113_ = self->priv->column;
#line 247 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	valadoc_markup_source_location_init (&_vala_token_end, _tmp111_, _tmp112_, _tmp113_ - 1);
#line 249 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = type;
#line 249 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (token_begin) {
#line 249 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		*token_begin = _vala_token_begin;
#line 1640 "markupreader.c"
	}
#line 249 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (token_end) {
#line 249 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		*token_end = _vala_token_end;
#line 1646 "markupreader.c"
	}
#line 249 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 1650 "markupreader.c"
}


static gchar* valadoc_markup_reader_text (ValadocMarkupReader* self, gchar end_char, gboolean rm_trailing_whitespace) {
	gchar* result = NULL;
	GString* content = NULL;
	GString* _tmp0_ = NULL;
	gchar* text_begin = NULL;
	gchar* _tmp1_ = NULL;
	gchar* last_linebreak = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp99_ = NULL;
	gchar* _tmp100_ = NULL;
	gint _tmp107_ = 0;
	gchar* _tmp108_ = NULL;
	gchar* _tmp109_ = NULL;
	gboolean _tmp110_ = FALSE;
	GString* _tmp129_ = NULL;
	const gchar* _tmp130_ = NULL;
	gchar* _tmp131_ = NULL;
#line 252 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 253 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = g_string_new ("");
#line 253 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	content = _tmp0_;
#line 254 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = self->priv->current;
#line 254 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	text_begin = _tmp1_;
#line 255 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp2_ = self->priv->current;
#line 255 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	last_linebreak = _tmp2_;
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	while (TRUE) {
#line 1687 "markupreader.c"
		gboolean _tmp3_ = FALSE;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		gunichar u = 0U;
		gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		gunichar _tmp12_ = 0U;
		gunichar _tmp13_ = 0U;
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp4_ = self->priv->current;
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp5_ = self->priv->end;
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp4_ < _tmp5_) {
#line 1703 "markupreader.c"
			gchar* _tmp6_ = NULL;
			gchar _tmp7_ = '\0';
			gchar _tmp8_ = '\0';
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp6_ = self->priv->current;
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp7_ = _tmp6_[0];
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp8_ = end_char;
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp3_ = _tmp7_ != _tmp8_;
#line 1715 "markupreader.c"
		} else {
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp3_ = FALSE;
#line 1719 "markupreader.c"
		}
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (!_tmp3_) {
#line 257 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			break;
#line 1725 "markupreader.c"
		}
#line 258 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp9_ = self->priv->current;
#line 258 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp10_ = self->priv->end;
#line 258 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp11_ = self->priv->current;
#line 258 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp12_ = g_utf8_get_char_validated ((const gchar*) _tmp9_, (gssize) ((glong) (_tmp10_ - _tmp11_)));
#line 258 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		u = _tmp12_;
#line 259 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp13_ = u;
#line 259 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp13_ == ((gunichar) (-1))) {
#line 1741 "markupreader.c"
			ValadocErrorReporter* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			gint _tmp16_ = 0;
			gchar* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
#line 260 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp14_ = self->priv->reporter;
#line 260 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp15_ = self->priv->_filename;
#line 260 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp16_ = self->priv->line;
#line 260 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp17_ = g_strdup_printf ("%s:%d", _tmp15_, _tmp16_);
#line 260 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp18_ = _tmp17_;
#line 260 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			valadoc_error_reporter_simple_error (_tmp14_, _tmp18_, "invalid UTF-8 character", NULL);
#line 260 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_g_free0 (_tmp18_);
#line 1761 "markupreader.c"
		} else {
			gunichar _tmp19_ = 0U;
#line 262 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp19_ = u;
#line 262 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			if (_tmp19_ == ((gunichar) '&')) {
#line 1768 "markupreader.c"
				gchar* next_pos = NULL;
				gchar* _tmp20_ = NULL;
				gunichar _tmp21_ = 0U;
				gint _tmp22_ = 0;
				gchar* _tmp23_ = NULL;
				gboolean _tmp24_ = FALSE;
#line 263 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp20_ = self->priv->current;
#line 263 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp21_ = u;
#line 263 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp22_ = g_unichar_to_utf8 (_tmp21_, NULL);
#line 263 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				next_pos = _tmp20_ + _tmp22_;
#line 264 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp23_ = next_pos;
#line 264 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp24_ = g_str_has_prefix ((const gchar*) _tmp23_, "amp;");
#line 264 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				if (_tmp24_) {
#line 1789 "markupreader.c"
					GString* _tmp25_ = NULL;
					gchar* _tmp26_ = NULL;
					gchar* _tmp27_ = NULL;
					gchar* _tmp28_ = NULL;
					gchar* _tmp29_ = NULL;
					gchar* _tmp30_ = NULL;
					GString* _tmp31_ = NULL;
					gchar* _tmp32_ = NULL;
					gchar* _tmp33_ = NULL;
#line 265 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp25_ = content;
#line 265 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp26_ = text_begin;
#line 265 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp27_ = self->priv->current;
#line 265 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp28_ = text_begin;
#line 265 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp29_ = string_substring ((const gchar*) _tmp26_, (glong) 0, (glong) ((gint) (_tmp27_ - _tmp28_)));
#line 265 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp30_ = _tmp29_;
#line 265 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					g_string_append (_tmp25_, _tmp30_);
#line 265 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_g_free0 (_tmp30_);
#line 266 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp31_ = content;
#line 266 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					g_string_append_c (_tmp31_, '&');
#line 267 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp32_ = self->priv->current;
#line 267 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					self->priv->current = _tmp32_ + 5;
#line 268 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp33_ = self->priv->current;
#line 268 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					text_begin = _tmp33_;
#line 1827 "markupreader.c"
				} else {
					gchar* _tmp34_ = NULL;
					gboolean _tmp35_ = FALSE;
#line 269 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp34_ = next_pos;
#line 269 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp35_ = g_str_has_prefix ((const gchar*) _tmp34_, "quot;");
#line 269 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					if (_tmp35_) {
#line 1837 "markupreader.c"
						GString* _tmp36_ = NULL;
						gchar* _tmp37_ = NULL;
						gchar* _tmp38_ = NULL;
						gchar* _tmp39_ = NULL;
						gchar* _tmp40_ = NULL;
						gchar* _tmp41_ = NULL;
						GString* _tmp42_ = NULL;
						gchar* _tmp43_ = NULL;
						gchar* _tmp44_ = NULL;
#line 270 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp36_ = content;
#line 270 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp37_ = text_begin;
#line 270 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp38_ = self->priv->current;
#line 270 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp39_ = text_begin;
#line 270 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp40_ = string_substring ((const gchar*) _tmp37_, (glong) 0, (glong) ((gint) (_tmp38_ - _tmp39_)));
#line 270 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp41_ = _tmp40_;
#line 270 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						g_string_append (_tmp36_, _tmp41_);
#line 270 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_g_free0 (_tmp41_);
#line 271 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp42_ = content;
#line 271 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						g_string_append_c (_tmp42_, '"');
#line 272 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp43_ = self->priv->current;
#line 272 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						self->priv->current = _tmp43_ + 6;
#line 273 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp44_ = self->priv->current;
#line 273 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						text_begin = _tmp44_;
#line 1875 "markupreader.c"
					} else {
						gchar* _tmp45_ = NULL;
						gboolean _tmp46_ = FALSE;
#line 274 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp45_ = next_pos;
#line 274 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						_tmp46_ = g_str_has_prefix ((const gchar*) _tmp45_, "apos;");
#line 274 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
						if (_tmp46_) {
#line 1885 "markupreader.c"
							GString* _tmp47_ = NULL;
							gchar* _tmp48_ = NULL;
							gchar* _tmp49_ = NULL;
							gchar* _tmp50_ = NULL;
							gchar* _tmp51_ = NULL;
							gchar* _tmp52_ = NULL;
							GString* _tmp53_ = NULL;
							gchar* _tmp54_ = NULL;
							gchar* _tmp55_ = NULL;
#line 275 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp47_ = content;
#line 275 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp48_ = text_begin;
#line 275 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp49_ = self->priv->current;
#line 275 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp50_ = text_begin;
#line 275 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp51_ = string_substring ((const gchar*) _tmp48_, (glong) 0, (glong) ((gint) (_tmp49_ - _tmp50_)));
#line 275 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp52_ = _tmp51_;
#line 275 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							g_string_append (_tmp47_, _tmp52_);
#line 275 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_g_free0 (_tmp52_);
#line 276 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp53_ = content;
#line 276 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							g_string_append_c (_tmp53_, '\'');
#line 277 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp54_ = self->priv->current;
#line 277 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							self->priv->current = _tmp54_ + 6;
#line 278 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp55_ = self->priv->current;
#line 278 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							text_begin = _tmp55_;
#line 1923 "markupreader.c"
						} else {
							gchar* _tmp56_ = NULL;
							gboolean _tmp57_ = FALSE;
#line 279 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp56_ = next_pos;
#line 279 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							_tmp57_ = g_str_has_prefix ((const gchar*) _tmp56_, "lt;");
#line 279 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
							if (_tmp57_) {
#line 1933 "markupreader.c"
								GString* _tmp58_ = NULL;
								gchar* _tmp59_ = NULL;
								gchar* _tmp60_ = NULL;
								gchar* _tmp61_ = NULL;
								gchar* _tmp62_ = NULL;
								gchar* _tmp63_ = NULL;
								GString* _tmp64_ = NULL;
								gchar* _tmp65_ = NULL;
								gchar* _tmp66_ = NULL;
#line 280 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp58_ = content;
#line 280 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp59_ = text_begin;
#line 280 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp60_ = self->priv->current;
#line 280 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp61_ = text_begin;
#line 280 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp62_ = string_substring ((const gchar*) _tmp59_, (glong) 0, (glong) ((gint) (_tmp60_ - _tmp61_)));
#line 280 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp63_ = _tmp62_;
#line 280 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								g_string_append (_tmp58_, _tmp63_);
#line 280 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_g_free0 (_tmp63_);
#line 281 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp64_ = content;
#line 281 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								g_string_append_c (_tmp64_, '<');
#line 282 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp65_ = self->priv->current;
#line 282 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								self->priv->current = _tmp65_ + 4;
#line 283 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp66_ = self->priv->current;
#line 283 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								text_begin = _tmp66_;
#line 1971 "markupreader.c"
							} else {
								gchar* _tmp67_ = NULL;
								gboolean _tmp68_ = FALSE;
#line 284 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp67_ = next_pos;
#line 284 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								_tmp68_ = g_str_has_prefix ((const gchar*) _tmp67_, "gt;");
#line 284 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
								if (_tmp68_) {
#line 1981 "markupreader.c"
									GString* _tmp69_ = NULL;
									gchar* _tmp70_ = NULL;
									gchar* _tmp71_ = NULL;
									gchar* _tmp72_ = NULL;
									gchar* _tmp73_ = NULL;
									gchar* _tmp74_ = NULL;
									GString* _tmp75_ = NULL;
									gchar* _tmp76_ = NULL;
									gchar* _tmp77_ = NULL;
#line 285 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp69_ = content;
#line 285 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp70_ = text_begin;
#line 285 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp71_ = self->priv->current;
#line 285 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp72_ = text_begin;
#line 285 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp73_ = string_substring ((const gchar*) _tmp70_, (glong) 0, (glong) ((gint) (_tmp71_ - _tmp72_)));
#line 285 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp74_ = _tmp73_;
#line 285 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									g_string_append (_tmp69_, _tmp74_);
#line 285 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_g_free0 (_tmp74_);
#line 286 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp75_ = content;
#line 286 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									g_string_append_c (_tmp75_, '>');
#line 287 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp76_ = self->priv->current;
#line 287 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									self->priv->current = _tmp76_ + 4;
#line 288 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp77_ = self->priv->current;
#line 288 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									text_begin = _tmp77_;
#line 2019 "markupreader.c"
								} else {
									gchar* _tmp78_ = NULL;
									gboolean _tmp79_ = FALSE;
#line 289 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp78_ = next_pos;
#line 289 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									_tmp79_ = g_str_has_prefix ((const gchar*) _tmp78_, "percnt;");
#line 289 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
									if (_tmp79_) {
#line 2029 "markupreader.c"
										GString* _tmp80_ = NULL;
										gchar* _tmp81_ = NULL;
										gchar* _tmp82_ = NULL;
										gchar* _tmp83_ = NULL;
										gchar* _tmp84_ = NULL;
										gchar* _tmp85_ = NULL;
										GString* _tmp86_ = NULL;
										gchar* _tmp87_ = NULL;
										gchar* _tmp88_ = NULL;
#line 290 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp80_ = content;
#line 290 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp81_ = text_begin;
#line 290 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp82_ = self->priv->current;
#line 290 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp83_ = text_begin;
#line 290 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp84_ = string_substring ((const gchar*) _tmp81_, (glong) 0, (glong) ((gint) (_tmp82_ - _tmp83_)));
#line 290 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp85_ = _tmp84_;
#line 290 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										g_string_append (_tmp80_, _tmp85_);
#line 290 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_g_free0 (_tmp85_);
#line 291 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp86_ = content;
#line 291 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										g_string_append_c (_tmp86_, '>');
#line 292 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp87_ = self->priv->current;
#line 292 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										self->priv->current = _tmp87_ + 8;
#line 293 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp88_ = self->priv->current;
#line 293 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										text_begin = _tmp88_;
#line 2067 "markupreader.c"
									} else {
										gchar* _tmp89_ = NULL;
										gunichar _tmp90_ = 0U;
										gint _tmp91_ = 0;
#line 295 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp89_ = self->priv->current;
#line 295 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp90_ = u;
#line 295 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										_tmp91_ = g_unichar_to_utf8 (_tmp90_, NULL);
#line 295 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
										self->priv->current = _tmp89_ + _tmp91_;
#line 2080 "markupreader.c"
									}
								}
							}
						}
					}
				}
			} else {
				gunichar _tmp92_ = 0U;
				gchar* _tmp95_ = NULL;
				gunichar _tmp96_ = 0U;
				gint _tmp97_ = 0;
				gint _tmp98_ = 0;
#line 298 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp92_ = u;
#line 298 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				if (_tmp92_ == ((gunichar) '\n')) {
#line 2097 "markupreader.c"
					gint _tmp93_ = 0;
					gchar* _tmp94_ = NULL;
#line 299 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp93_ = self->priv->line;
#line 299 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					self->priv->line = _tmp93_ + 1;
#line 300 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					self->priv->column = 0;
#line 301 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp94_ = self->priv->current;
#line 301 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					last_linebreak = _tmp94_;
#line 2110 "markupreader.c"
				}
#line 304 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp95_ = self->priv->current;
#line 304 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp96_ = u;
#line 304 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp97_ = g_unichar_to_utf8 (_tmp96_, NULL);
#line 304 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				self->priv->current = _tmp95_ + _tmp97_;
#line 305 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp98_ = self->priv->column;
#line 305 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				self->priv->column = _tmp98_ + 1;
#line 2124 "markupreader.c"
			}
		}
	}
#line 309 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp99_ = text_begin;
#line 309 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp100_ = self->priv->current;
#line 309 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (_tmp99_ != _tmp100_) {
#line 2134 "markupreader.c"
		GString* _tmp101_ = NULL;
		gchar* _tmp102_ = NULL;
		gchar* _tmp103_ = NULL;
		gchar* _tmp104_ = NULL;
		gchar* _tmp105_ = NULL;
		gchar* _tmp106_ = NULL;
#line 310 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp101_ = content;
#line 310 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp102_ = text_begin;
#line 310 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp103_ = self->priv->current;
#line 310 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp104_ = text_begin;
#line 310 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp105_ = string_substring ((const gchar*) _tmp102_, (glong) 0, (glong) ((gint) (_tmp103_ - _tmp104_)));
#line 310 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp106_ = _tmp105_;
#line 310 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		g_string_append (_tmp101_, _tmp106_);
#line 310 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_g_free0 (_tmp106_);
#line 2157 "markupreader.c"
	}
#line 313 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp107_ = self->priv->column;
#line 313 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp108_ = self->priv->current;
#line 313 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp109_ = last_linebreak;
#line 313 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->column = _tmp107_ + ((gint) (_tmp108_ - _tmp109_));
#line 316 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp110_ = rm_trailing_whitespace;
#line 316 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	if (_tmp110_) {
#line 2171 "markupreader.c"
		gchar* str_pos = NULL;
		GString* _tmp111_ = NULL;
		const gchar* _tmp112_ = NULL;
		GString* _tmp113_ = NULL;
		gssize _tmp114_ = 0L;
		GString* _tmp125_ = NULL;
		gchar* _tmp126_ = NULL;
		GString* _tmp127_ = NULL;
		const gchar* _tmp128_ = NULL;
#line 317 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp111_ = content;
#line 317 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp112_ = _tmp111_->str;
#line 317 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp113_ = content;
#line 317 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp114_ = _tmp113_->len;
#line 317 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		str_pos = ((gchar*) _tmp112_) + _tmp114_;
#line 2191 "markupreader.c"
		{
			gchar* _tmp115_ = NULL;
			gboolean _tmp116_ = FALSE;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp115_ = str_pos;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			str_pos = _tmp115_ - 1;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp116_ = TRUE;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			while (TRUE) {
#line 2203 "markupreader.c"
				gboolean _tmp118_ = FALSE;
				gchar* _tmp119_ = NULL;
				GString* _tmp120_ = NULL;
				const gchar* _tmp121_ = NULL;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				if (!_tmp116_) {
#line 2210 "markupreader.c"
					gchar* _tmp117_ = NULL;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp117_ = str_pos;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					str_pos = _tmp117_ - 1;
#line 2216 "markupreader.c"
				}
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp116_ = FALSE;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp119_ = str_pos;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp120_ = content;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				_tmp121_ = _tmp120_->str;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				if (_tmp119_ > ((gchar*) _tmp121_)) {
#line 2228 "markupreader.c"
					gchar* _tmp122_ = NULL;
					gchar _tmp123_ = '\0';
					gboolean _tmp124_ = FALSE;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp122_ = str_pos;
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp123_ = _tmp122_[0];
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp124_ = g_ascii_isspace (_tmp123_);
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp118_ = _tmp124_;
#line 2240 "markupreader.c"
				} else {
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					_tmp118_ = FALSE;
#line 2244 "markupreader.c"
				}
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
				if (!_tmp118_) {
#line 318 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
					break;
#line 2250 "markupreader.c"
				}
			}
		}
#line 319 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp125_ = content;
#line 319 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp126_ = str_pos;
#line 319 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp127_ = content;
#line 319 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp128_ = _tmp127_->str;
#line 319 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		g_string_erase (_tmp125_, (gssize) ((_tmp126_ - ((gchar*) _tmp128_)) + 1), (gssize) (-1));
#line 2264 "markupreader.c"
	}
#line 322 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp129_ = content;
#line 322 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp130_ = _tmp129_->str;
#line 322 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp131_ = g_strdup (_tmp130_);
#line 322 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = _tmp131_;
#line 322 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_string_free0 (content);
#line 322 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 2278 "markupreader.c"
}


static void valadoc_markup_reader_space (ValadocMarkupReader* self) {
#line 325 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_if_fail (self != NULL);
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	while (TRUE) {
#line 2287 "markupreader.c"
		gboolean _tmp0_ = FALSE;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		gchar* _tmp6_ = NULL;
		gchar _tmp7_ = '\0';
		gchar* _tmp9_ = NULL;
		gint _tmp10_ = 0;
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp1_ = self->priv->current;
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp2_ = self->priv->end;
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp1_ < _tmp2_) {
#line 2301 "markupreader.c"
			gchar* _tmp3_ = NULL;
			gchar _tmp4_ = '\0';
			gboolean _tmp5_ = FALSE;
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp3_ = self->priv->current;
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp4_ = _tmp3_[0];
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp5_ = g_ascii_isspace (_tmp4_);
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp0_ = _tmp5_;
#line 2313 "markupreader.c"
		} else {
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp0_ = FALSE;
#line 2317 "markupreader.c"
		}
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (!_tmp0_) {
#line 326 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			break;
#line 2323 "markupreader.c"
		}
#line 327 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp6_ = self->priv->current;
#line 327 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp7_ = _tmp6_[0];
#line 327 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		if (_tmp7_ == '\n') {
#line 2331 "markupreader.c"
			gint _tmp8_ = 0;
#line 328 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			_tmp8_ = self->priv->line;
#line 328 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			self->priv->line = _tmp8_ + 1;
#line 329 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
			self->priv->column = 0;
#line 2339 "markupreader.c"
		}
#line 331 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp9_ = self->priv->current;
#line 331 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->current = _tmp9_ + 1;
#line 332 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		_tmp10_ = self->priv->column;
#line 332 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		self->priv->column = _tmp10_ + 1;
#line 2349 "markupreader.c"
	}
}


const gchar* valadoc_markup_reader_get_filename (ValadocMarkupReader* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 34 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = self->priv->_filename;
#line 34 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = _tmp0_;
#line 34 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 2365 "markupreader.c"
}


static void valadoc_markup_reader_set_filename (ValadocMarkupReader* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 33 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_if_fail (self != NULL);
#line 33 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = value;
#line 33 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 33 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_free0 (self->priv->_filename);
#line 33 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->_filename = _tmp1_;
#line 33 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_object_notify ((GObject *) self, "filename");
#line 2384 "markupreader.c"
}


const gchar* valadoc_markup_reader_get_name (ValadocMarkupReader* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 39 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = self->priv->_name;
#line 39 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = _tmp0_;
#line 39 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 2399 "markupreader.c"
}


static void valadoc_markup_reader_set_name (ValadocMarkupReader* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_if_fail (self != NULL);
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = value;
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_free0 (self->priv->_name);
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->_name = _tmp1_;
#line 38 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_object_notify ((GObject *) self, "name");
#line 2418 "markupreader.c"
}


const gchar* valadoc_markup_reader_get_content (ValadocMarkupReader* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 44 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = self->priv->_content;
#line 44 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	result = _tmp0_;
#line 44 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	return result;
#line 2433 "markupreader.c"
}


static void valadoc_markup_reader_set_content (ValadocMarkupReader* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_return_if_fail (self != NULL);
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = value;
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_free0 (self->priv->_content);
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->_content = _tmp1_;
#line 43 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_object_notify ((GObject *) self, "content");
#line 2452 "markupreader.c"
}


static void valadoc_markup_reader_class_init (ValadocMarkupReaderClass * klass) {
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	valadoc_markup_reader_parent_class = g_type_class_peek_parent (klass);
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_type_class_add_private (klass, sizeof (ValadocMarkupReaderPrivate));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_markup_reader_get_property;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_markup_reader_set_property;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	G_OBJECT_CLASS (klass)->finalize = valadoc_markup_reader_finalize;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_MARKUP_READER_FILENAME, g_param_spec_string ("filename", "filename", "filename", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_MARKUP_READER_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_MARKUP_READER_CONTENT, g_param_spec_string ("content", "content", "content", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 2473 "markupreader.c"
}


static void valadoc_markup_reader_instance_init (ValadocMarkupReader * self) {
	GeeHashMap* _tmp0_ = NULL;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv = VALADOC_MARKUP_READER_GET_PRIVATE (self);
#line 57 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 57 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->attributes = (GeeMap*) _tmp0_;
#line 2485 "markupreader.c"
}


static void valadoc_markup_reader_finalize (GObject* obj) {
	ValadocMarkupReader * self;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_TYPE_MARKUP_READER, ValadocMarkupReader);
#line 32 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_free0 (self->priv->_filename);
#line 37 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_free0 (self->priv->_name);
#line 42 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_free0 (self->priv->_content);
#line 47 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_mapped_file_unref0 (self->priv->mapped_file);
#line 49 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	self->priv->lines = (_vala_array_free (self->priv->lines, self->priv->lines_length1, (GDestroyNotify) g_free), NULL);
#line 57 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_object_unref0 (self->priv->attributes);
#line 60 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	_g_object_unref0 (self->priv->reporter);
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	G_OBJECT_CLASS (valadoc_markup_reader_parent_class)->finalize (obj);
#line 2509 "markupreader.c"
}


/**
 * Simple reader for a subset of XML.
 */
GType valadoc_markup_reader_get_type (void) {
	static volatile gsize valadoc_markup_reader_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_markup_reader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocMarkupReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_markup_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocMarkupReader), 0, (GInstanceInitFunc) valadoc_markup_reader_instance_init, NULL };
		GType valadoc_markup_reader_type_id;
		valadoc_markup_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "ValadocMarkupReader", &g_define_type_info, 0);
		g_once_init_leave (&valadoc_markup_reader_type_id__volatile, valadoc_markup_reader_type_id);
	}
	return valadoc_markup_reader_type_id__volatile;
}


static void _vala_valadoc_markup_reader_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ValadocMarkupReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_TYPE_MARKUP_READER, ValadocMarkupReader);
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		case VALADOC_MARKUP_READER_FILENAME:
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		g_value_set_string (value, valadoc_markup_reader_get_filename (self));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		break;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		case VALADOC_MARKUP_READER_NAME:
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		g_value_set_string (value, valadoc_markup_reader_get_name (self));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		break;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		case VALADOC_MARKUP_READER_CONTENT:
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		g_value_set_string (value, valadoc_markup_reader_get_content (self));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		break;
#line 2551 "markupreader.c"
		default:
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		break;
#line 2557 "markupreader.c"
	}
}


static void _vala_valadoc_markup_reader_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ValadocMarkupReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_TYPE_MARKUP_READER, ValadocMarkupReader);
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
	switch (property_id) {
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		case VALADOC_MARKUP_READER_FILENAME:
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		valadoc_markup_reader_set_filename (self, g_value_get_string (value));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		break;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		case VALADOC_MARKUP_READER_NAME:
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		valadoc_markup_reader_set_name (self, g_value_get_string (value));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		break;
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		case VALADOC_MARKUP_READER_CONTENT:
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		valadoc_markup_reader_set_content (self, g_value_get_string (value));
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		break;
#line 2585 "markupreader.c"
		default:
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 31 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/markupreader.vala"
		break;
#line 2591 "markupreader.c"
	}
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 2599 "markupreader.c"
		int i;
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
				destroy_func (((gpointer*) array)[i]);
#line 2607 "markupreader.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
	g_free (array);
#line 2619 "markupreader.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
	if (array) {
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
		while (((gpointer*) array)[length]) {
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
			length++;
#line 2632 "markupreader.c"
		}
	}
#line 198 "/builddir/build/BUILD/valadoc-0.35.0/src/libvaladoc/moduleloader.vala"
	return length;
#line 2637 "markupreader.c"
}



